function []  =   checkRieman(k,rowsJ,Sspec,C_tau,C_tau_N,tol)

%computes covariances by integrating a spectrum, Sspec, between -pi and pi, and
%compares the resulting covariances with the covariances in C_tau.

C_tau_bf = zeros(rowsJ,rowsJ,k+1);

for kkk = 1:k+1
    C_tau_bf(:,:,kkk) = real(Sspec(:,:,1));
    for jjj = 2:C_tau_N
        w = (pi*(jjj-1))/C_tau_N;
        C_tau_bf(:,:,kkk) = C_tau_bf(:,:,kkk) + Sspec(:,:,jjj)*exp(sqrt(-1)*w*(kkk-1)) + Sspec(:,:,jjj).'*exp(-sqrt(-1)*w*(kkk-1));
    end
    %C_tau_bf(:,:,kkk) = (real(C_tau_bf(:,:,kkk)) + real(Sspec(:,:,C_tau_N+1)*exp(sqrt(-1)*pi*(kkk-1))))/(2*C_tau_N);
    C_tau_bf(:,:,kkk) = (C_tau_bf(:,:,kkk) + Sspec(:,:,C_tau_N+1)*exp(sqrt(-1)*pi*(kkk-1)) )/(2*C_tau_N);
end

%Check on the C(tau)s - this difference should be about 0 if both ways of computing C_tau are correct
C_tau_diff = max(max(max(abs(C_tau - C_tau_bf))));

if C_tau_diff > tol
    fprintf('Alternative ways of implementing Rieman sums give %15.12f difference',C_tau_diff);    
end