function [XXXr,XXXd,trendm1,trendm3,trendiy,date] = eurodata(first_avb_obs,start_estimation,end_estimation,calvohours,user,outfolder)

%This function contains the data for the euro area which are used to construct the matrix XXX. This matrix contains the
%time series of the variables that we consider "observable" in the estimation. 
%The data used to be in the excel file called CMR_data1.xls

load ea_March09_final.mat 


% GDP = GDP. Current prices, millions of euro. Seasonally adjusted.
% Cons = Consumption (non-durables+durables+services. Current prices. Millions of euro. SA
% Invest = Investment. Current prices. (residential, non-residential, equipment, plants, business durables, government investment, change in inventories. In millions. SA)
% Gov_Con = Government consumption. Current prices. Millions of euro. SA
% Net_exp = Net exports. Current prices. Millions. Seasonally adjusted. XTN-MTN
% Ind_taxes = Indirect taxes collected, nominal. Millions
% HICP = HICP (1996=100). SA. At irrevocabile fixed rate of conversion. It is taken from Barbara
% GDP_def_fp = GDP deflator at factor price. 1995=1. Seasonally adjusted
% GDP_def_mp = GDP deflator at market price. (1995=1). Seasonally adjusted
% I_def = Investment deflator. 1995=1
% C_def = Consumption deflator (1995=1)
% Gcon_def = Government Consumption deflator (1995=1)
% capacity = capacity utilization in manufacturing. SA
% Stock = Dow Jones Eurostock (1970-1986 is MSCI Europe price index. From 1987 is Dow Jones euro stock . Both are PE. They are spliced together)
% M3 = M3, end of period. SA. Adjusted for German unification. Millions. It is taken from Barbara
% M1 = M1. Millions. SA (it is constructed adding together currency and overnight deposits. It is not taken from the series labelled M1 in Barbara). Adjusted for German reunification.
% Currency  = Currency in circulation(banknotes+coins-vault cash). Millions. SA
% Dem_dep = Demand deposits. Milions. SA
% Re = Interest rate on 3-month Euribor. APR
% R_10= Interest rate on long-term treasury Bond (10 years). APR
% R_2= Interest rate on 2 year bonds. APR
% R_5= Interest rate on 5 year bonds. APR
% Loans = Banks' Loans to the private sector. Notional Stock. SA
% oil = oil price in euro (brent, per barrel). It starts in 1982Q1
% TotEmpl = Total employment (persons)
% pop= It is working-age population (between 15 and 64 years old). Million
% EmplCompens = total compensation of employees
% Employees = Employees (persons)
% R_a = rate on demand deposits
% R_m = rate on (M3-M1)
% Net_factor = net factor income from abroad
% Hours = hours worked per quarter 
% Compens=compensation/hours
% dating

dating = [1980.0:0.25:2008.25]';

dating = [[1:length(dating)]', dating]; 

tt = [find((dating(:,2)==start_estimation)):find((dating(:,2)==end_estimation))]; 
date = dating(tt,2);

y_all = 1; %=1 include net exports; =0 exclude net exports
GDP_ = GDP;
if y_all==0
    GDP = GDP-Net_exp;
end
%-------------------------------------------------------------------------
% Net factor income from abroad. Current prices. Millions. SA
% NOT UPDATED
Net_factor=[7861.6614 
9050.0237 
9516.9034 
9878.3598 
7120.4250 
7464.3964 
5941.3410 
6132.2607 
4037.5525 
8589.7244 
7599.4523 
5006.9086 
7264.9636 
6600.7628 
6262.3666 
4442.4725 
1374.7261 
1417.7911 
-3.7225 
-3323.3762 
-1929.8011 
-1872.4352 
-2338.5177 
-5010.6278 
-6534.5131 
-9300.3630 
-5941.4255 
-10857.4581 
-3823.4745 
-5229.5092 
-2519.7590 
-4655.2966 
-3333.3339 
-3414.3036 
-2520.4964 
-4857.8875 
-8619.8088 
-242.7498 
139.5854 
3587.5141 
-6568.3243 
-103.4092 
-2784.3603 
-5612.3809 
-5914.4179 
-5904.4409 
-5333.1909 
-9418.2800 
-11335.1151 
-10028.9332 
-17754.1775 
-11243.8107 
-13470.8960 
-10806.8487 
-10592.0506 
-4119.6423 
-11804.9663 
-13243.4919 
-10153.3586 
-4918.0002 
-9241.9641 
-5953.3107 
-4933.0073 
-7592.1012 
-8716.3628 
-6433.7010 
-3422.7582 
-8036.2183 
-4153.5220 
-18201.8541 
-20427.3016 
-13140.5881 
-28082.8734 
-23322.4494 
-23726.3406 
-18842.1757 
-28061.6767 
-23388.4382 
-22442.4471 
-19448.6368 
-16417.0920 
-15325.0530 
-12963.6668 
-8886.4972 
-5867.6512 
-17616.9414 
-7414.3063 
-14416.1988 
-12910.7530 
-33833.0851 
-24798.7184 
-17825.6834 
-15303.7477 
-25193.7918 
-26608.2852 
-17673.5201 
-15295.0907 
17456.1670 
17746.3119 
17964.6485 
18010.1640
NaN
NaN
NaN
NaN
NaN%];
NaN%];
NaN
NaN
NaN
NaN
NaN
NaN
NaN]; 
  
%--------------------------------
%Risk premium. APR.
Risk_P =[0.20734435 %March09
1.450379367
2.273136867
1.5638964
2.069054767
2.1315214
1.5428166
2.824446133
1.9154962
1.8840568
1.5822134
1.876422967
1.410487467
0.8362439
0.323456767
0.413536
0.922574133
0.6526364
0.974208067
1.655578067
1.6146064
1.459072667
1.672039933
1.660787467
2.144137233
2.366789267
1.957723267
1.670641
1.625034553
1.810729533
1.275886819
0.878746688
1.241224964
0.92121776
0.427370876
0.389500892
0.1
0.698128208
0.649338704
0.503278964
0.420557948
0.915613563
0.793366342
0.384000943
0.624552917
1.125729702
1.027527219
0.905634337
1.087891616
0.991750272
0.841768109
1.557464325
1.591840961
2.271643937
2.31203037
2.294768889
2.30638481
2.357567019
2.164672396
1.951609675
1.65290311
1.805853638
2.128037931
2.17463457
2.641240678
2.825615674
2.735693967
2.39289992
2.108019099
1.93620252
1.700653218
1.450228314
1.539277607
1.34564149
1.354773137
1.461127216
1.443105298
1.415552592
1.125575421
0.899617921
0.911473222
0.824895427
0.792147965
1.033187342
1.309308929
1.287574584
1.422350828
1.653797595
1.249805175
1.246560295
1.586095789
1.776571649
1.947713289
1.889380353
1.611778619
1.545968594
1.738962588
1.507933691
1.479714838
1.527401611
1.397852776
1.55533245
1.505276334
1.244404567
1.119254164
0.96919945
0.984909708
0.96346944
0.922199301 %2007Q1  
0.86676147 
1.066  %2007Q3
1.266  
1.466 %2008Q1
1.566]; %2008Q2


%Hours, March09
Hours=[40.38407
40.25545
40.12723
40.03637
40.05784
39.89209
39.8808
39.70268
39.75682
39.70884
39.6813
39.53252
39.37663
39.44626
39.51535
39.533
39.48347
39.25441
39.34633
39.44274
39.25467
39.36407
39.40726
39.52722
39.56703
39.66001
39.72489
39.93437
39.86418
40.00107
40.12422
40.25472
40.50741
40.44639
40.62246
40.74603
40.9713
40.87682
41.04416
41.23559
41.5044
41.64669
41.80015
41.83054
42.00759
41.91507
41.76296
41.7757
41.80258
41.74072
41.38103
40.9708
40.6554
40.41968
40.319
40.10457
40.16225
40.19098
40.25045
40.20207
40.19656
40.21206
40.2509
40.23519
40.06746
40.15438
40.23861
40.22422
40.19956
40.26228
40.36572
40.47113
40.63321
40.74857
40.91798
41.03454
41.14406
41.2349
41.39966
41.57895
41.78181
42.00178
42.1534
42.36571
42.40397
42.47441
42.53193
42.52783
42.43983
42.38957
42.41806
42.35647
42.2986
42.34823
42.49638
42.60802
42.6484
42.65417
42.86781
42.95042
42.8778
42.89377
42.9831
43.16095
43.19576
43.5328
43.5984
43.80631
44.04066
44.27134
44.44067
44.57052
44.71079
44.75935];

%--------------------------------------------------------------------------
if start_estimation < first_avb_obs
    error('fatal (eurodata) you selected a starting date for estimation that falls outside the available data sample')
elseif end_estimation > dating(end,2)
    error('fatal (eurodata) you selected an ending date for estimation that falls outside the available data sample')
end
%----------------------------------
HICP=HICP/100;

Compens = EmplCompens;
Employ = TotEmpl;


%Compensation (Nominal terms) and Hours
if calvohours==1
    Compens = (Compens./Employ); %(Compens./Employees); %per person 
    log_Hours = log(Employ) - ([1:length(Employ)]*(0.008/4))'; %0.008 is the annual increase in labour supply
else
    Compens = ((Compens./Employees).*Employ)./Hours; %per hour
    log_Hours = log(Hours./pop); %hours per capita
end
    

%Log Currency to deposit ratio
log_curr_dep=log(Currency./Dem_dep);

%set the interbank rate equal to the short rate
R_b = R_e;

%set to zero negative values of Risk Premium
for ij = 1:length(tt)
    if Risk_P(tt(ij)) < 0
        Risk_P(tt(ij)) = 0
    end
end

%----------------------------------

%construct HICP inflation
for ii = 2:length(dating(:,1))
    infl_hicp(ii,1)=log(HICP(ii,1)/HICP(ii-1,1));
end

%to match the concept entailed by our variables in the model and in the data, as constructed in the national accounts, 
%we make some adjustments. 1) construct GNP. 2) adjust investment to take into account the presence of net factor income. 
%3) Adjust investment to also take into account that our model is a closed economy. Net exports should thus be included in investment; 
%It might also be considered to: 4) subtract indirect taxes from GNP; 5) subtract indirect taxes from
%consumption. For details, see the note Appendix_data

GNP_adj        = GDP+Net_factor; %GNP_adj    = GNP_adj-Ind_taxes;
Invest_adj = Invest + Net_factor + Net_exp;
Cons_adj = Cons; %Cons_adj   = Cons-Ind_taxes;

%construct ratios (C/Y, I/Y)
log_C_Y      = log(Cons./GDP);
log_C_Y_adj  = log(Cons./GNP_adj); %log_C_Y_adj  = log(Cons_adj./GNP_adj);

nominal = 1; %=1 (nominal investment/nominal output); =0 (nominal investment/investment deflator)/(nominal output/consumer price inflation)
if nominal ==1
    log_I_Y      = log(Invest./GDP); 
    log_I_Y_adj  = log(Invest_adj./GNP_adj);
elseif nominal ==0
    log_I_Y      = log((Invest./I_def)./(GDP./HICP)); 
    log_I_Y_adj  = log((Invest_adj./I_def)./(GNP_adj./HICP));
end

log_Loan_Y = log(Loans./GDP);

%Construct real output growth per capita
y_hicp=GDP./(pop.*HICP);
y_adj_hicp=GNP_adj./(pop.*HICP);

y_def = GDP./(pop.*GDP_def_mp);

for ii = 2:length(dating(:,1))
    Dy_hicp(ii,1)=log(y_hicp(ii,1)/y_hicp(ii-1,1));
    Dy_adj_hicp(ii,1)=log(y_adj_hicp(ii,1)/y_adj_hicp(ii-1,1));
    
    Dy_def(ii,1)=log(y_def(ii,1)/y_def(ii-1,1));
end

%---------------------------------------
checkss=0; %recall that variable GDP_ contains data on GDP with all components in, whereas variable GDP may exclude Net_exp (epends on what you have set in y_all at the beginning of this program)
if checkss==1
    y_def_ = (GDP_)./GDP_def_mp;
    ypc_def = (GDP_)./(pop.*GDP_def_mp);
    ynt_def = (GDP_-Net_exp)./(pop.*GDP_def_mp);
    for ii = 5:length(dating(:,1))
        Dypc4_def(ii,1)=log(ypc_def(ii,1)/ypc_def(ii-4,1));
        Dy4_def(ii,1)=log(y_def_(ii,1)/y_def_(ii-4,1));
        Dy4_nt(ii,1)=log(ynt_def(ii,1)/ynt_def(ii-4,1));
    end
    for ii = 2:length(dating(:,1))
        Dypc_def(ii,1)=log(ypc_def(ii,1)/ypc_def(ii-1,1));
        Dy_def(ii,1)=log(y_def_(ii,1)/y_def_(ii-1,1));
        Dy_nt(ii,1)=log(ynt_def(ii,1)/ynt_def(ii-1,1));
    end
    for ii = 4 : length(dating(:,1))
        Dy1(ii) = Dypc_def(ii)+Dypc_def(ii-1)+Dypc_def(ii-2)+Dypc_def(ii-3);
        Dy2(ii) = Dy_def_(ii)+Dy_def_(ii-1)+Dy_def_(ii-2)+Dy_def_(ii-3);
        Dy3(ii) = Dy_nt(ii)+Dy_nt(ii-1)+Dy_nt(ii-2)+Dy_nt(ii-3);
    end
    figure;plot(date(end-40:end),100*Dy4_nt(end-40:end),'r-*',date(end-40:end),100*Dypc4_def(end-40:end),'g-d',date(end-40:end),100*Dy4_def(end-40:end),'k')
    legend('domestic only, per capita','per capita','no transformations');title('GDP Growth, y-o-y');grid on
    figure;plot(date(end-40:end),100*Dy_nt(end-40:end),'r-*',date(end-40:end),100*Dypc_def(end-40:end),'g-d',date(end-40:end),100*Dy_def(end-40:end),'k')
    legend('domestic only, per capita','per capita','no transformations');title('GDP Growth, quarterly annualise');grid on
    figure;plot(date(end-40:end),100*Dy3(end-40:end),'r-*',date(end-40:end),100*Dy1(end-40:end),'g-d',date(end-40:end),100*Dy2(end-40:end),'k')
    legend('domestic only, per capita','per capita','no transformations');title('GDP Growth, y-o-y');grid on
end
%-----------------------------------------------------------

%Construct real consumption growth per capita
%Rcons = Cons./(pop.*C_def);
Rcons = Cons./(pop.*GDP_def_mp);
for ii = 2:length(dating(:,1))
    Dcons(ii,1)=log(Rcons(ii,1)/Rcons(ii-1,1));
end

%Construct real investment growth per capita
Rinvest = Invest./(pop.*I_def);
%Rinvest = Invest./(pop.*GDP_def_mp);
for ii = 2:length(dating(:,1))
    Dinvest(ii,1)=log(Rinvest(ii,1)/Rinvest(ii-1,1));
end

%Construct real net-worth growth per capita
Rstock = Stock./(pop.*HICP);
Rstock_def = Stock./(pop.*GDP_def_mp);
for ii = 2:length(dating(:,1))
    Dstock(ii,1)=log(Rstock(ii,1)/Rstock(ii-1,1));
    Dstock_def(ii,1)=log(Rstock_def(ii,1)/Rstock_def(ii-1,1));
end

%Construct hourly real wage growth 
Rcompens = Compens./HICP;
Rcompens_def = Compens./GDP_def_mp;
for ii = 2:length(dating(:,1))
     Dcompens(ii,1)=log(Rcompens(ii,1)/Rcompens(ii-1,1));
     Dcompens_def(ii,1)=log(Rcompens_def(ii,1)/Rcompens_def(ii-1,1));
end

%Construct real M3 growth per capita
%%%WARNING!!! See M3-M1:
m3_m1 = 0; %=0, M3; =1, M3-M1
if m3_m1 == 1
    M3=M3-M1;
end
Rm3 = M3./(pop.*HICP);
Rm3_def = M3./(pop.*GDP_def_mp);
for ii = 2:length(dating(:,1))
    Dm3(ii,1)=log(Rm3(ii,1)/Rm3(ii-1,1));
    Dm3_def(ii,1)=log(Rm3_def(ii,1)/Rm3_def(ii-1,1));
end

%Construct real M1 growth per capita
Rm1 = M1./(pop.*HICP);
Rm1_def = M1./(pop.*GDP_def_mp);
for ii = 2:length(dating(:,1))
    Dm1(ii,1)=log(Rm1(ii,1)/Rm1(ii-1,1));
    Dm1_def(ii,1)=log(Rm1_def(ii,1)/Rm1_def(ii-1,1));
end

%Construct real Loans growth per capita
Rloans_def = Loans./(pop.*GDP_def_mp);
for ii = 2:length(dating(:,1))
    Drloans_def(ii,1)=log(Rloans_def(ii,1)/Rloans_def(ii-1,1));
end

%Construct real government consumption growth per capita and net export growth
Gov_Con_r = Gov_Con./(pop.*Gcon_def);
Net_exp_r = Net_exp./(pop.*GDP_def_mp);
%Exog_comp_r = Gov_Con./(pop.*GDP_def_mp) + Net_exp_r;
Exog_comp_r = (GDP-Cons-Invest)./(pop.*GDP_def_mp);
for ii = 2:length(dating(:,1))
    Dgov_con(ii,1)=log(Gov_Con_r(ii,1)/Gov_Con_r(ii-1,1));
    Dexog_comp(ii,1) = log(Exog_comp_r(ii,1)/Exog_comp_r(ii-1,1));
end
if y_all ==0
    Dexog_comp = Dgov_con;
end

%fit a AR(1) process on government consumption
if y_all==1
    Y = log(Exog_comp_r(tt(1)+16:tt(end))); %16 is the initialisation of the kalman filter
elseif y_all==0
    Y = log(Gov_Con_r(tt(1)+16:tt(end)));
end
X=[ones(size(Y,1),1) [1:size(Y,1)]'];
bet=(X'*X)\(X'*Y);
Y_detrend = Y - X(:,2)*bet(2,1) - X(:,1)*bet(1,1);

YY = Y_detrend(2:end); 
XX = Y_detrend(1:end-1);
bet=(XX'*XX)\(XX'*YY);
res_YY = YY - XX*bet;
%disp(['Fitting a linear trend: rho_g = ' num2str(bet) ', std of g = ' num2str(std(res_YY)/100)]);

Y_detrend = hpfilt(length(Y),1600)*log(Y);
YY = Y_detrend(2:end); 
XX = Y_detrend(1:end-1);
bet=(XX'*XX)\(XX'*YY);
res_YY = YY - XX*bet;
%disp(['HP filter (1600): rho_g = ' num2str(bet) ', std of g= ' num2str(std(res_YY)/100)]);


%Construct growth rate of investment deflator
for ii = 2:length(dating(:,1))
    Dinv_def(ii,1)=log(I_def(ii,1)/I_def(ii-1,1));
end

P_inv = I_def./GDP_def_mp;

%Construct growth rate of consumption deflator
for ii = 2:length(dating(:,1))
    Dcon_def(ii,1)=log(C_def(ii,1)/C_def(ii-1,1));
end

%Construct growth rate of GDP deflator
for ii = 2:length(dating(:,1))
    Ddef_gdp(ii,1)=log(GDP_def_mp(ii,1)/GDP_def_mp(ii-1,1));
end
% for ii = 4 : length(dating(:,1))
%     Ddef_gdp4(ii) = Ddef_gdp(ii)+Ddef_gdp(ii-1)+Ddef_gdp(ii-2)+Ddef_gdp(ii-3);
%     Dhicp4(ii) = infl_hicp(ii)+infl_hicp(ii-1)+infl_hicp(ii-2)+infl_hicp(ii-3);
% end 
% figure; plot(dating(tt,2),100*Ddef_gdp4(tt),'r',dating(tt,2),100*Dhicp4(tt),'g')

%Construct M1 velocity
log_Vel_M1      = log(GDP./M1);
log_Vel_M1_adj  = log(GNP_adj./M1);
log_M1_Y      = log(M1./GDP);

%Construct M3 velocity
log_Vel_M3      = log(GDP./M3);
log_Vel_M3_adj  = log(GNP_adj./M3);
log_M3_Y      = log(M3./GDP);

%Costruct the ratio of wage over per capita output
log_W_Y     = log(Compens./(GDP./pop));
log_W_Y_adj = log(Compens./(GNP_adj./pop));

%Construct the ratio of net worth over output
log_N_Y      =  log(Stock./GDP);
log_N_Y_adj  =  log(Stock./GNP_adj); 


%remove trend in Vel_M1
dotrendm1 = 0; %=0 do NOT detrend M1
if dotrendm1 ==1 
    X=[ones(length(tt),1) [1:length(tt)]'];
    bhat=((X'*X)\X')*log_Vel_M1(tt,1); 
    trendm1=X(:,2)*bhat(2,1);
    log_Vel_M1  = log_Vel_M1(tt,1) - trendm1;    
    
    bhat=((X'*X)\X')*log_Vel_M1_adj(tt,1); 
    trendm1_adj =X(:,2)*bhat(2,1);
    log_Vel_M1_adj  = log_Vel_M1_adj(tt,1) - trendm1_adj;
else
    log_Vel_M1  = log_Vel_M1(tt,1);
    trendm1 = zeros(length(tt),1); 
    log_Vel_M1_adj  = log_Vel_M1_adj(tt,1);
    trendm1_adj = zeros(length(tt),1);
end

%remove trend in Vel_M3
dotrendm3 = 0; %do NOT detrend M3
if dotrendm3 ==1
    bhat=((X'*X)\X')*log_Vel_M3(tt,1); 
    trendm3  = X(:,2)*bhat(2,1);
    log_Vel_M3   =  log_Vel_M3(tt,1) - trendm3 ;
    
    bhat=((X'*X)\X')*log_Vel_M3_adj(tt,1); 
    trendm3_adj =X(:,2)*bhat(2,1);
    log_Vel_M3_adj  = log_Vel_M3_adj(tt,1) - trendm3_adj;
else
    log_Vel_M3   =  log_Vel_M3(tt,1);
    trendm3 = zeros(length(tt),1); 
    log_Vel_M3_adj  = log_Vel_M3_adj(tt,1);
    trendm3_adj = zeros(length(tt),1);

end

%remove trend in I_Y
if nominal ==0
    bhat=((X'*X)\X')*log_I_Y(tt,1);
    trendiy      =  X(:,2)*bhat(2,1);
    log_I_Y      = log_I_Y(tt,1) - trendiy;
    
    bhat=((X'*X)\X')*log_I_Y_adj(tt,1);
    trendiy_adj     =  X(:,2)*bhat(2,1);
    log_I_Y_adj     = log_I_Y_adj(tt,1) - trendiy_adj;
else
    log_I_Y      = log_I_Y(tt,1);
    trendiy = zeros(length(tt),1); 
    log_I_Y_adj  = log_I_Y_adj(tt,1);
    trendiy_adj = zeros(length(tt),1);

end

%Construct growth rate of real oil price and demeaned it
for ii = 2:length(dating(:,1))
    Doil(ii,1)=log(oil(ii,1)/oil(ii-1,1));
end
Doil_real = Doil - Ddef_gdp;
Doil_real = Doil_real(tt) - mean(Doil_real(tt));

%Construct growth rate of banks'reserves in real terms
Reserves_real = (liq_def_a)./(pop.*GDP_def_mp);
for ii = 2:length(dating(:,1))
    Dreserves(ii,1) = log(Reserves_real(ii)/Reserves_real(ii-1));
end

%construct XXX
adj_on  =0; %=1 use GNP and adjust investment for net exports
if adj_on == 0
    %XXXr     = [log_N_Y(tt), infl_hicp(tt), log_Hours(tt), log_Loan_Y(tt), Dy_def(tt), log_W_Y(tt), log_I_Y, log_Vel_M1, log_Vel_M3, log_C_Y(tt), Risk_P(tt), (R_10(tt)-R_e(tt)), R_a(tt), R_e(tt), log(capacity(tt)), Dexog_comp(tt), Dinv_def(tt)-Dcon_def(tt), Doil_real, (R_2(tt)-R_e(tt)), dreserves];
    XXXr     = [log_N_Y(tt), infl_hicp(tt), log_Hours(tt), log_Loan_Y(tt), Dy_def(tt), log_W_Y(tt), log_I_Y, log_M1_Y(tt), log_M3_Y(tt), log_C_Y(tt), Risk_P(tt), (R_10(tt)-R_e(tt)), R_a(tt), R_e(tt), log(capacity(tt)), Dexog_comp(tt), P_inv(tt), Doil_real, (R_2(tt)-R_e(tt)), Dreserves(tt)];
    XXXd     = [Dstock_def(tt), Ddef_gdp(tt), log_Hours(tt), Drloans_def(tt), Dy_def(tt), Dcompens_def(tt), Dinvest(tt), Dm1_def(tt), Dm3_def(tt), Dcons(tt), Risk_P(tt), (R_10(tt)-R_e(tt)), R_a(tt), R_e(tt), log(capacity(tt)), Dexog_comp(tt), Dinv_def(tt)-Ddef_gdp(tt), Doil_real, (R_2(tt)-R_e(tt)), Dreserves(tt)];
elseif adj_on == 1
    XXXr = [log_N_Y_adj(tt), infl_hicp(tt), log(Hours(tt)), Drloans_def(tt), Dy_adj_hicp(tt), log_W_Y_adj(tt), log_I_Y_adj, log_Vel_M1_adj log_Vel_M3_adj, log_C_Y_adj(tt), Risk_P(tt), R_10(tt), R_a(tt), R_e(tt), log(capacity(tt))];
    trendm1 = trendm1_adj;
    trendm3 = trendm3_adj;
    trendiy = trendiy_adj;
end

%these are data used to compute the cross-correlations..
term=(R_10-R_e);
save([outfolder '\data_ea'], 'log_Hours', 'Rstock_def', 'Rcons', 'Rinvest', 'Risk_P', 'Ddef_gdp', 'y_def', 'Rloans_def', 'date', 'tt', 'term', 'R_e', 'Rm3_def', 'Rm1_def');

%save d:\banking\euroarea_data\XNX XXXr XXXd trendm1 trendm3 trendiy

makeplot=0;
if makeplot == 1
    figure
    subplot(4,4,1)
    plot(dating(tt,2),log_N_Y(tt))
    axis tight
    title('N/Y')
    
    subplot(4,4,2)
    plot(dating(tt,2),infl_hicp(tt))
    axis tight
    title('Inflation')
    
    subplot(4,4,3)
    plot(dating(tt,2),log(Hours(tt)))
    axis tight
    title('Hours Worked')
    
    subplot(4,4,4)
    plot(dating(tt,2),R_b(tt))
    axis tight
    title('Rb')
    
    subplot(4,4,5)
    plot(dating(tt,2),Dy_hicp(tt))
    axis tight
    title('Output Growth')
    
    subplot(4,4,6)
    plot(dating(tt,2),log_W_Y(tt))
    axis tight
    title('W/Y')
    
    subplot(4,4,7)
    plot(dating(tt,2),log_I_Y)
    axis tight
    title('I/Y')
    
    subplot(4,4,8)
    plot(dating(tt,2),log_Vel_M1)
    axis tight
    title('Velocity M1')
    
    subplot(4,4,9)
    plot(dating(tt,2),log_Vel_M3)
    axis tight
    title('Velocity M3')
    
    subplot(4,4,10)
    plot(dating(tt,2),log_C_Y(tt))
    axis tight
    title('C/Y')
    
    subplot(4,4,11)
    plot(dating(tt,2),Risk_P(tt))
    axis tight
    title('Risk Premium')
    
    subplot(4,4,12)
    plot(dating(tt,2),R_10(tt))
    axis tight
    title('10 years Interest Rate')
    
    subplot(4,4,13)
    plot(dating(tt,2),R_m(tt))
    axis tight
    title('Own Rate on M3')
    
    subplot(4,4,14)
    plot(dating(tt,2),R_e(tt))
    axis tight
    title('R_e')
    
    subplot(4,4,15)
    plot(dating(tt,2),log(capacity(tt)))
    axis tight
    title('Capacity')
    
    subplot(4,4,16)
    plot(dating(tt,2),(Net_exp(tt)./GDP(tt)));
    axis tight
    title('Net Export over Output')
end

do_plot =0;
if do_plot == 1
    euro=1; %=1 euroarea data; =0 US data
    if euro == 1
        str='Euro area Data (per capita terms). Fourth quarter of each year indicated by *';
    elseif euro == 0
        str='US Data (per capita terms). Fourth quarter of each year indicated by *';
    end    
    plot_rawdata
end