function [z,Gamma,G,n,k,invest,w,l,y,phi,g,c,uzc,vn,ix] = glide2(beta,b,psik,psil,R,rentk,Fomegabar,omegabar,sigma,we,gamma,muzstar, ...
   Re,pii,Retk,mu,s,delta,alpha,vk,lambdaf,etag,upsil,bigtheta,ix)

z           =   (log(omegabar)+sigma^2/2)/sigma;
Gamma       =   normcdf(z-sigma)+omegabar*(1-normcdf(z));
G           =   normcdf(z-sigma);
n           =   we/(1-gamma/muzstar*(1+Re)/pii-gamma/(pii*muzstar)*(Retk-Re-mu*(1+Retk)*G)/(1-(1+Retk)/(1+Re)*(Gamma-mu*G)));
k           =   n/(1-((1+Retk)/(1+Re))*(Gamma-mu*G));
if n < 0 | k < 0 | k < n
    ix(5)=1;
    error('(glide2) n < 0 | k < 0 | k < n')
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%check that the value found for omegabar, n, and k indeed satisfy their respective equations
%equation aa5
ee0         =  (1-Gamma)*s+((1-Fomegabar)/(1-Fomegabar-mu*omegabar*lognpdf(omegabar,-sigma^2/2,sigma))) ...
                  *(s*(Gamma-mu*G)-1);
%equation aa6
ee1         =  (k/n)-1/(1-s*(Gamma-mu*G));

%equation aa7
ee2         =  n-((gamma/(pii*muzstar))*(Retk-Re-mu*G*(1+Retk))*k+we)/(1-gamma*((1+Re)/pii)/muzstar);
if abs(ee1) > .1e-10 | abs(ee2) > .1e-10 | abs(ee0) > .1e-9
    ix(6)=1;
    error('(glide2) eq. aa5, aa6 and/or aa7 are not satisfied')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%equation aa3
invest      =   k*(1-(1-delta)/(muzstar*upsil));

%equation aa1
w           =   ((1-alpha)^(1-alpha)*alpha^alpha/(lambdaf*(rentk*(1+psik*R))^alpha))^(1/(1-alpha))/(1+psil*R);

%equation aa2
l           =   (k/(muzstar*upsil))*((1-alpha)/alpha)*(rentk*(1+psik*R)/(w*(1+psil*R)));

%equation aa22
c      =   (1-etag)*((vk*((k/(muzstar*upsil))^alpha)*(l^(1-alpha)))/lambdaf - bigtheta*((1-gamma)/gamma)*(n-we) - mu*G*(1+Retk)*k/(muzstar*pii))-invest;

%equation aa24
y           =   (c+invest)/(1-etag);

% fix cost of production aa23
phi         =   vk*((k/(muzstar*upsil))^alpha)*(l^(1-alpha))*(1-1/lambdaf);

% equation for g aa25
g           =   etag*y;

%equation for vn aa26
vn        =   (1/gamma)*(n-we);

%equation aa24
uzc        =  (muzstar-b*beta)/((muzstar-b)*c);

if invest < 0 | w < 0 | l < 0 | c < 0 | uzc < 0
    ix(7)=1;
    error('(glide2) invest < 0 | w < 0 | l < 0 | c < 0 | uzc < 0')
end
