function [xini,P] = initmykalman(data,T,Z,Q,H,xini,P,alf,init_kal)

for i=1:init_kal
    
    Ft = Z*P*Z'+ H; % observables' forecast error
    
    if rcond(Ft) > 1e-15
    %if det(Ft) > 1e-35
        invFt = pinv(Ft);
        if any(diag(invFt)<0)
            error('invFt is not psd')
        end
    else
        return
    end
    
    ut = data(:,i)-(Z*xini) - alf;
    
    % start the filter
    Kt   = T*P*Z'*invFt; %Kalman gain (see Hamilton p. 381)
    xini = T*xini + Kt*ut; 
    %L    = T - Kt*Z;
    %P    = T*P*L'+ Q; %update of MSE of projection of state variables
    P = T*P*T' - Kt*Z*P*T' + Q;
end
