function [decomp_new,categ,cmap,lgx_] = make_categ(decomp,tauvar,taushock,categ,signal_on,parstoch)

decomp    = decomp';
ncat      = size(categ,1); % # of categories of shocks
nvar      = length(tauvar);

cmap = [];
for ij = 1:ncat
    cmap = [cmap; categ{ij,3}];
end
lgx_ = categ(:,1);

% -- First, drop from each category the shocks that are not in taushock 
%Second, find the location of each shock and re-number it according to its location in taushock
%Third, check whether shocks have also a signal and if it is the case, adjust numbering accordingly. Recall that the contribution of signal shock is stored right after the standard shock itself
ii = 0;
for jj = 1:length(taushock)
    ii = ii+1;
    taushocknew(ii) = taushock(jj); %creating room for shocks with signal activated
    if max(signal_on==taushock(jj))==1
        ii = ii+parstoch(taushock(jj));
    end
end
categxx = [];
for ii = 1:ncat
    xx = categ{ii,2};
    for ij = 1:length(taushock)
        if max(xx==taushock(ij))==1
            categxx = [categxx find(taushocknew==taushock(ij))];
            if max(signal_on==taushock(ij))==1 %if taushock(ij) has a signal activated(signal_on is a vector containing the number of the shocks that have a signal and is produced in shockanalysis
               categxx = [categxx [categxx(end)+1:categxx(end)+parstoch(taushock(ij))]];
            end
        end
    end
    categ{ii,2} = categxx;
    categxx = [];
end
      
% -- group the simulations in categories 
decomp_new = [];
nshocks=0;
for ii = 1:length(taushock)
    nshocks=nshocks+1+parstoch(taushock(ii));
end

for jj = 1:nvar
    for ii = 1:ncat
        decomp_new = [decomp_new, sum( decomp(:,nshocks*(jj-1)+categ{ii,2}),2)];
    end
end

