function maketable_vardec(Vardec_cmr,Vardec_fish,Vardec_bgg,Vardec_sw,Vardec_b,cycle1,cycle2,name,frequency, ...
nameshock,namevariable,taushock_cmr,taushock_bgg,taushock_b,taushock_fish,taushock_sw,tauvar_cmr,tauvar_bgg, ...
tauvar_b,tauvar_fish,tauvar_sw,signal_cmr,signal_bgg,signal_b,signal_fish,signal_sw,outfolder,cdir,parstoch,switcher)

n_col= size(nameshock,1); %this # includes the activated signals

legend_str = 'For each variable, figures for the benchmark model are in the first row. The alternative models, if present, are in the following rows.';

%inflate the size of Vardec in alternative models in order to make it same size as benchmark model
indx_row = [];
if isempty(Vardec_fish)==0
    [Vardec_fish]=maketable_vardec_util(Vardec_fish,taushock_fish,tauvar_fish,signal_fish,signal_cmr,taushock_cmr,tauvar_cmr,parstoch,n_col);
    legend_str = [legend_str ' Benchmark model with no Fisher effect is denoted by [()].']; 
    indx_row = [indx_row; 1];
else
    indx_row = [indx_row; 0];
end
if isempty(Vardec_bgg)==0
    [Vardec_bgg]=maketable_vardec_util(Vardec_bgg,taushock_bgg,tauvar_bgg,signal_bgg,signal_cmr,taushock_cmr,tauvar_cmr,parstoch,n_col);
    legend_str = [legend_str ' Financial Accelerator model is denoted by ().']; 
    indx_row = [indx_row; 1];
else
    indx_row = [indx_row; 0];
end
if isempty(Vardec_b)==0
    [Vardec_b]=maketable_vardec_util(Vardec_b,taushock_b,tauvar_b,signal_b,signal_cmr,taushock_cmr,tauvar_cmr,parstoch,n_col);
    legend_str = [legend_str ' Model Without Entrepreneuers is denoted by (()).']; 
    indx_row = [indx_row; 1];
else
    indx_row = [indx_row; 0];
end
if isempty(Vardec_sw)==0
    [Vardec_sw]=maketable_vardec_util(Vardec_sw,taushock_sw,tauvar_sw,signal_sw,signal_cmr,taushock_cmr,tauvar_cmr,parstoch,n_col);
    legend_str = [legend_str ' Simple model is denoted by [].']; 
    indx_row = [indx_row; 1];
else
    indx_row = [indx_row; 0];
end


ncol = n_col+1; %additional column allows for variables' names
lengthxx = length(tauvar_cmr);

if switcher==1
    fid=fopen([outfolder '\write_temp_big_bc.m'],'w');
elseif switcher==2
    fid=fopen([outfolder '\write_temp_big_lf.m'],'w');
end

fprintf(fid,['fid = fopen(''' [strrep(cdir,'\','\\') '\\' outfolder(3:end) '\\' name] ''',''w''); \n']);

fprintf(fid,'fprintf(fid,'' \\\\documentclass{article} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\usepackage{amsfonts} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\usepackage{amsmath} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\setcounter{MaxMatrixCols}{10} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{OutputFilter=LATEX.DLL} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{Version=4.10.0.2345} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{Created=Thursday, October 31, 2002 05:55:21} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{LastRevised=Thursday, October 31, 2002 06:08:51} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{<META NAME="DocumentShell" CONTENT="Standard LaTeX\\\\Standard LaTeX Article">} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{CSTFile=40 LaTeX article.cst} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\newtheorem{theorem}{Theorem} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{acknowledgement}[theorem]{Acknowledgement} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{algorithm}[theorem]{Algorithm} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{axiom}[theorem]{Axiom} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{case}[theorem]{Case} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{claim}[theorem]{Claim} \\n''); \n' );
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{conclusion}[theorem]{Conclusion} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{condition}[theorem]{Condition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{conjecture}[theorem]{Conjecture} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{corollary}[theorem]{Corollary} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{criterion}[theorem]{Criterion} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{definition}[theorem]{Definition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{example}[theorem]{Example} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{exercise}[theorem]{Exercise} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{lemma}[theorem]{Lemma} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{notation}[theorem]{Notation} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{problem}[theorem]{Problem} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{proposition}[theorem]{Proposition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{remark}[theorem]{Remark} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{solution}[theorem]{Solution} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{summary}[theorem]{Summary} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newenvironment{proof}[1][Proof]{\\\\noindent\\\\textbf{#1.} }{\\\\ \\\\rule{0.5em}{0.5em}} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\input{tcilatex} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\begin{document} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\begin{equation*} \\n''); \n');

nn = '|l||';
for ii=1:ncol-1
    nn = [nn 'c|'];
end
fprintf(fid,['fprintf(fid,'' \\\\begin{tabular}{' nn '} \\\\hline \\n ''); \n']);

fprintf(fid,['fprintf(fid,'' \\\\multicolumn{' num2str(ncol) '}{|c|}{Table: Variance Decomposition at ' frequency ' Frequencies in Alternative Models (in percent) } \\\\\\\\ [1.5ex] \\\\hline \\n ''); \n']);

fprintf(fid,' keyboard  \n');


nameshock_ = ['''$' deblank(nameshock(1,:)) '$'''];
ssf = '\\\\multicolumn{1}{|c|}{%%s}';
for ii=2:ncol-1
    nameshock_ = [nameshock_ ',''$' deblank(nameshock(ii,:)) '$'''];
    ssf = [ssf '& \\\\multicolumn{1}{|c|}{%%s}'];
end
ssf = ['multicolumn{1}{|l||}{}& ' ssf];

fprintf(fid,['fprintf(fid, '' \\\\'  ssf ' \\\\\\\\  [1.5ex] \\\\hline \\\\hline \\n'',' nameshock_ '); \n']);

for ii=1:lengthxx
    rowii = num2str(Vardec_cmr(ii,1),2);
    for jj=2:ncol-1
        rowii = [rowii ' & ' num2str(Vardec_cmr(ii,jj),2)];
    end
    rowii = ['multicolumn{1}{|l||}{' namevariable(tauvar_cmr(ii),1:10) '} & ' rowii];

    %we need to know whether variable ii is present also in other models in order to draw or not the horizontal line below
    if indx_row(1,1) ==1
        if all(isnan(Vardec_fish(ii,:))) == 0
            indx_row(1,2) = 1;
        end
    end
    if indx_row(2,1) ==1
        if all(isnan(Vardec_bgg(ii,:))) == 0
           indx_row(2,2) = 1;
        end
    end 
    if indx_row(3,1) ==1
        if all(isnan(Vardec_b(ii,:))) == 0
          indx_row(3,2) = 1;
        end
    end 
    if indx_row(4,1) ==1
        if all(isnan(Vardec_sw(ii,:))) == 0
          indx_row(4,2) = 1;
        end
    end 
    
    if sum(indx_row(:,2))>=1
        line_string = ' ';
    else
        line_string = ' \\\\hline';
    end

    fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\ ' line_string ' \\n''); \n']);

    if isempty(Vardec_fish)==0
        if all(isnan(Vardec_fish(ii,:)))==0
            if isnan(Vardec_fish(ii,1))==1
                rowii = '[(--)]';
            else
                rowii = ['[(' num2str(Vardec_fish(ii,1),2) ')]'];
            end
            for jj=2:ncol-1
                if isnan(Vardec_fish(ii,jj))==1
                    rowii = [rowii ' & ' '[(--)]'];
                else
                    rowii = [rowii ' & [(' num2str(Vardec_fish(ii,jj),2) ')]'];
                end
            end
            rowii = [' & ' rowii];
            
            if sum(indx_row(2:end,2))>=1
               line_string = ' ';
            else
               line_string = ' \\\\hline';
            end
            fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\ ' line_string '  \\n''); \n']);
        end
    end
    if isempty(Vardec_bgg)==0
        if all(isnan(Vardec_bgg(ii,:)))==0
            if isnan(Vardec_bgg(ii,1))==1
                rowii = '(--)';
            else
                rowii = ['(' num2str(Vardec_bgg(ii,1),2) ')'];
            end
            for jj=2:ncol-1
                if isnan(Vardec_bgg(ii,jj))==1
                    rowii = [rowii ' & ' '(--)'];
                else
                    rowii = [rowii ' & (' num2str(Vardec_bgg(ii,jj),2) ')'];
                end
            end
            rowii = [' & ' rowii];
            
            if sum(indx_row(3:end,2))>=1
               line_string = ' ';
            else
               line_string = ' \\\\hline';
            end
            
            fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\ '  line_string ' \\n''); \n']);
        end
    end
    if isempty(Vardec_b)==0
        if all(isnan(Vardec_b(ii,:)))==0
            if isnan(Vardec_b(ii,1))==1
                rowii = '((--))';
            else
                rowii = ['((' num2str(Vardec_b(ii,1),2) '))'];
            end
            for jj=2:ncol-1
                if isnan(Vardec_b(ii,jj))==1
                    rowii = [rowii ' & ' '((--))'];
                else
                    rowii = [rowii ' & ((' num2str(Vardec_b(ii,jj),2) '))'];
                end
            end
            rowii = [' & ' rowii];
            
            if sum(indx_row(4:end,2))>=1
               line_string = ' ';
            else
               line_string = ' \\\\hline';
            end
            
            fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\ ' line_string ' \\n''); \n']);
        end
    end
    if isempty(Vardec_sw)==0
        if all(isnan(Vardec_sw(ii,:)))==0
            if isnan(Vardec_sw(ii,1))==1
                rowii = '[--]';
            else
                rowii = ['[' num2str(Vardec_sw(ii,1),2) ']'];
            end
            for jj=2:ncol-1
                if isnan(Vardec_sw(ii,jj))==1
                    rowii = [rowii ' & ' '[--]'];
                else
                    rowii = [rowii ' & [' num2str(Vardec_sw(ii,jj),2) ']'];
                end
            end
            rowii = [' & ' rowii];
            fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\  \\\\hline \\n''); \n']);
        end
    end
    
    indx_row(:,2) = 0;
end

fprintf(fid,'fprintf(fid,'' \\\\end{tabular}%%%% \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\end{equation*}%%%% \\n''); \n');

fprintf(fid,['fprintf(fid,'' {\\\\small Legend: }{\\\\small ' legend_str '}\\n''); \n']);

fprintf(fid,['fprintf(fid,'' {\\\\small Note: }{\\\\small Variance decomposition corresponds to periodic components with cycles of ' num2str(cycle1) '-' num2str(cycle2) ' quarters, obtained using the model spectrum.}\\n''); \n']);

fprintf(fid,'fprintf(fid,'' \\\\end{document} \\n''); \n');
fprintf(fid,'fclose(fid);');

fclose(fid);

addpath([cdir outfolder(2:end)])
if switcher==1
    write_temp_big_bc
elseif switcher==2
    write_temp_big_lf
end
rmpath([cdir outfolder(2:end)])
