%-------------------------------------------------------------------------
%    Set parameter values for euroarea 
%-------------------------------------------------------------------------

% NOTE: priors related to the following parameters are set in set_params_priors.m

% Warning: Not ALL parameters are set in this file.
% parameters related to time series representation of shocks (and their respective priors) are set in parametersstoch.m
% *taumat...the vector that specifies the shocks that are not observed in partial-information equations, is set in makealphabeta.m
% *checkB contains taup, a list of variables not observed in partial information equations 
% *checkB also contains part, a list of the partial information equations

%---Household
lambdaw     =   1.05;                 % CEE page 22
%l           =   0.49333469458685;                    
sigmaL      =   1;                    % CEE page 21
zeta        =   1.000;                % ??
theta       =   0.74; %0.745; %0.74032;%0.886095; %% 
v           =   1.2*0.001;  %  .00000002; 
beta        =   0.995;%1.00401002003506^(-0.25); %1.02^(-0.25);% 1.03^(-.25);  CEE page 21      % 
xiw         =   0.818;%0.8397; %    % CEE page 42
Hdoupr      =   0;
sigmaq      =   -6*0.5;%-8;
b           =   .56;   %from S&W               % 0.63 in CEE page 42 .63
psiL        =   2.06897560422264;
m           =   0.69;
chii        =   0.83*0.4851; %0.45832;%0.52;   % it governs the sostituibility between Dm and more liquid asset in the utility function
duration1   =   40; %duration of the long bond (number of quarters)
duration2   =   8;
zetac       =   1; %consumption preference shock
term        =   1; %term premium shock
iotaw1      =   0.757; %0.87345; % %estimated on 23 September 2005; 0.318;%degree of indexation to inflation target
iotaw2      =   1-iotaw1;;%degree of indexation to past inflation
iotamu      =   0.887;%1;%imposed on 23 September; degree of indexation of wage to stochastic productivity growth

%---- Entrepreneur
Fomegabar   =   0.6*0.026; %0.0285;     %0.008; % BGG page 33 (.03)
sigma       =   0.5*0.35497304397609;  %variance of shock omega
mu          =   0.0999; %0.0938;     %0.12;   % BGG page 33 (.12)      monitoring cost 
gamma       =   (1-0.022)*1.005; %1-0.027; %1-0.0272;     % BGG page 33 1-0.0272;      1 - "death rate"
we          =   0.02;                 % ??                
bigtheta    =   0.02; %0.05;
tauo        =   1; %0.05;


%----- Capital Producer
sigmaa      =   27.1; ; %0.172     
Sdoupr      =   11.2; %5.0;      % elasticity in dynamic specification of adjustment costs %ACEL page 49  7.69
etai        =   2;      %elasticity in static specification of adjustment costs
muup        =   1;  %investment specific shock 
zetai       =   1;  %shock to the marginal efficiency of investment

%---- Goods Producers
muzstar     =   1.015^(.25);          % ??
upsil       =   1.002^(.25);   %trend in relative price of consumption
phi         =   0.24530898644140;
rk          =   0.04195; %rk=.0435; great depression paper %rk=0.041225; euro area paper with m=0.7; %rk=0.04625; with delta=0.025 %rk=0.04124; with delta =0.02
lambdaf     =   1.2;                  % 
alpha       =   0.36;% 0.34;               % CEE page 21
psik        =   0.92;%1; %0                  % ??     fraction of k services financed in advance
psil        =   0.92;%1;%0.5; %0.1                   % ??     fraction of l services financed in advance
delta       =   0.02;              % CEE page 21
epsil       =   1;
xip         =   0.822;%0.8191; % %estimated on 23 September 2005; 0.802;              % CEE page 42
iota1       =   0.688; %0.22222; %estimated on 23 September 2005; 0.724;
iota2       =   1-iota1;

%----- Banks
ksi         =   0.93804261451082;
xb          =   1.025776244003187e+002;
chorse      =   0.155;%0.2; 
rhobank     =   0; %-40;
%R           =   0.00799899120600;
vl          =   0.99065;%0.99271;
vk          =   0.99065;%0.99271; 

%---- Taxes and government consumption
etag        =   0.23;            % ??
tauk        =   .28; % the corresponding measure in Linde et al. is 0.13              
taul        =   .45; %the corresponding measure in Linde et al. is 0.31          
tauc        =   0.2; %the corresponding measure in Linde et al. is 0.12       
taud        =   0;%0.005; %it has been removed in euro area model
taut = taud;                   % ??   

%---- Monetary Policy
tau         =   0.02;  %reserve requirement
x           =   0.00832;%0.00859;     %in the euro area base money growth over 1998:4-2003:2 is 3.5%
pibar       =   1;%wage/price setting index parameter, automatically set to steady state inflation when not optimizing policy
%pi = 1.00484285163744;

xp          =   0;
    
aptil       =  1.64; %0.5 coefficent on inflation in Taylor rule
aytil       =  0.194; %0.5 coefficient on output in Taylor rule
amtil       =  0.0356;%0.002; %coefficient on nominal M3 growth in Taylor rule
actil       =  0; 
rhotil      =  0.896;  %interest rate smoothing parameter in Taylor rule


