function plot_fig_autoc(name_fig,leg_str,k,nameXX,nn0,nn1,CCk_m_cell,CCk_var_cell,t100)
%INPUT:
%name_fig
%leg_str
%k,
%pp,
%nameXX,
%nn0,
%nn1,
%CCk_m_cell, cell array
%CCk_var_cell, cell array
%t100 = 100, results in the plot are multiplied by t100^2 in order to get the results we would get if the data were in percentage; otherwise set it to 1 

figure('name',name_fig), orient landscape

tt = 0:k;
length_m = size(CCk_m_cell,2);
length_e = size(CCk_var_cell,2);

ij=1;
for ii = nn0
    for jj = nn1
        
        subplot(length(nn0),length(nn1),ij);
        
        CCk_m_cell_plot = CCk_m_cell{1};
        
        plot(tt,t100^2*CCk_m_cell_plot(:,tt+1,ii,jj),'k-','LineWidth',2); 
        
        hold all
        for jk = 2:length_m
           CCk_m_cell_plot = CCk_m_cell{jk};
           if isempty(CCk_m_cell_plot) == 0
               plot(tt,t100^2*CCk_m_cell_plot(:,tt+1,ii,jj) ) ;
               %plot(tt,t100^2*CCk_m_cell_plot(:,tt+1,ii,jj),'Color',[0.8 0.8 0.8],'LineWidth',2); 
           end
        end
        
        for jk = 1:length_e
           CCk_var_cell_plot = CCk_var_cell{jk};
           if isempty(CCk_var_cell_plot) == 0
              plot(tt,t100^2*CCk_var_cell_plot(:,tt+1,ii,jj) );
              %plot(tt,t100^2*CCk_var_cell_plot(:,tt+1,ii,jj),'k:','LineWidth',2);
           end
        end
        title([deblank(nameXX(ii,:)),'_{t}',deblank(nameXX(jj,:)),'_{t-k}'],'FontName','Gill Sans MT','FontSize',8,'VerticalAlignment','Baseline')
        if ii ~= nn0(end)
           set(gca,'XTick',[tt(1)-1 tt(end)+1])
        end
        set(gca,'FontSize',8)
        axis tight
       
        hold off        
        
        ij = ij+1;
    end
end

leg = legend(leg_str);
set(leg, 'FontSize', 7,'Location','SouthEast');
hout = suptitle(['Figure: ' name_fig]);
