%Select parameters to be estimated, their bounds and priors. If a parameter is not estimated, it is set at the value specified in parameters files 

%To select parameters to be estimated and impose bounds use the following convention:
%II(ii,jj), ii = 1 stands for estimating the parameter, 0 stands for keeping it fixed
          %the value of jj matters if the associated parameter is to be estimated
             %jj = 1, restrict to unit interval
             %jj = 2, restrict to unit circle
             %jj = 3, restrict to be non-negative
             %jj = 4, restrict bigger than unity
             %jj = 5, no restriction

% AR(1) coefficients are restricted to lie in the unit interval
% stdd of shocks and signals are restricted to be non-negative
% stdd of measurement error are restricted to be non-negative

%To set priors use the following convention:             
%prior_nameparameter = [shape,location,dispersion]; %1th column is the prior shape; 2nd and 3rd are parameters used to compute density (opportunely transformed if needed)
                %shape: 1 is BETA(mean,stdd); parameters a and b needed to evaluate Beta distribution are computed automatically on the basis of the 'mean' and 'stdd'
                %       2 is INVGAMMA(mode,d); d stands for the degrees of freedom
                %       3 is NORMAL(mean,stdd)
                %       4 is uniform(a,b)
                %       5 is Gamma(mean,stdd)
                %       6 is Weibull(a,b); a governs roughly the mode and b the dispersion (>2 and the higher the tigher)
                    
II(8,1) = 1; II(8,2)=1; %1;%xiw
if country==1
    prior_xiw = [1,0.75,0.1];
elseif country ==2
    prior_xiw = [1,0.375,0.1]; 
end

II(9,1) = 1;II(9,2)=3; %3;%Hdoupr 
if entr == -1 || entr == -2 || entr ==-3 || country==2
    II(9,1) = 0;II(9,2)=3; %3;%Hdoupr 
end
prior_Hdoupr = [3,2,2];

II(22,1) = 1; II(22,2)=3; %3;%sigmaa 
prior_sigmaa = [5,6,5]; 

II(23,1) = 1;II(23,2)=3; %3;%Sdoupr
prior_Sdoupr = [3,10,5]; %[3,7.7,3.5];

II(35,1) = 1;II(35,2)=1; %1;%xip
if country ==1
    prior_xip = [1,0.75,0.05]; %prior_xip = [1,0.75,0.025];
elseif country ==2
    prior_xip = [1,0.375,0.05]; %[1,0.5,0.1];
end

II(51,1) = 1;II(51,2)=4; %4;%aptil
if country ==1
    prior_aptil = [3,1.75,0.1];
elseif country ==2
    prior_aptil = [3,1.75,0.1];
end

II(52,1) = 0;II(52,2)=3; %3; %aytil  0.1  0.075
if country ==1
    prior_aytil = [3,0.1,0.05];
elseif country ==2
    prior_aytil = [3,0.1,0.05];
end

if country ==1
    II(53,1) = 0; II(53,2)=3; %3;%amtil *****
    if entr ==-1 || entr == -2
        II(53,1) = 0; II(53,2)=3;
    end
    prior_amtil = [3,0.025,0.02]; % with the alternative Taylor rule, this used to be: prior_amtil = [3,0.06,0.05];
elseif country ==2
    II(53,1) = 0; II(53,2)=3; %3;%amtil *****
    prior_amtil = [3,0.025,0.02]; % with the alternative Taylor rule, this used to be: prior_amtil = [3,0.06,0.05];
end

if country ==1
    II(54,1) = 1; II(54,2)=3; %3;%actil % 
    if entr ==-1 || entr == -2% | entr ==-3
        II(54,1) = 0; II(54,2)=3; %3;%actil % 
    end
    prior_actil = [3,0.05,0.025];
elseif country ==2
    II(54,1) = 0; II(54,2)=3; %3;%actil % 
    prior_actil = [3,0.05,0.025];
end

II(55,1) = 1; II(55,2)=1; %1;%rhotil 
prior_rhotil = [1,0.8,0.05];

II(56,1) = 1; II(56,2)=1; %1;%iota1
prior_iota1 = [1,0.5,0.15];  

II(58,1) = 1; II(58,2)=1; %1;%iotaw1
prior_iotaw1 = [1,0.5,0.15]; %

II(60,1) = 1; II(60,2)=1; %1;%iotamu
prior_iotamu = [1,0.5,0.15]; 

II(61,1) = 1; II(61,2)=3; %3;%adptil   
prior_adptil = [3,0.3,0.1]; 

II(62,1) = 1; II(62,2)=3; %3;%adytil
prior_adytil = [3,0.25,0.1];

if calvohours==1
    II(63,1) = 1; II(63,2)=1; %xiE
else
    II(63,1) = 0; II(63,2)=1;    
end
prior_xiE = [1,0.5,0.1];

%--
II(64,1) = 0; II(64,2)=5; %par1 %alpha_pi
prior_par1 = [3,0,10]; 

II(65,1) = 0; II(65,2)=5; %par2 %alpha_dy
prior_par2 = [3,0,5]; 

II(66,1) = 0; II(66,2)=5; %par3 %alpha_dpi
prior_par3 = [3,0,10]; 

II(67,1) = 0; II(67,2)=5; %par4 %alpha_xi
prior_par4 = [3,0,10]; 

II(68,1) = 0; II(68,2)=3; %par5 %alpha_chi
prior_par5 = [3,2,1]; 

II(69,1) = 0; II(69,2)=5; %par6 %alpha_xb
prior_par6 = [3,0,10]; 

II(70,1) = 0; II(70,2)=1; %par7 %rho_MBR
prior_par7 = [1,0.5,0.25]; 

II(71,1) = 0; II(71,2)=5; %par8
prior_par8 = [3,0,0.5]; 

II(72,1) = 0; II(72,2)=3; %par9
prior_par9 = [3,1,0.5]; 

II(73,1) = 0; II(73,2)=1; %par10  
prior_par10 = [1,0.5,0.2]; 


%-------------------------------------------
II(3,1) = 0;II(3,2)=3;%sigmaL
p_3 = [5,2,1];

II(11,1) = 0;II(11,2)=1;%b
p_11 = [1,0.7,0.1]; %[1,0.6,0.2]

II(16,1) = 0;II(16,2)=1;%Fomegabar
p_16 = [1,0.026,0.008]; %0.015

II(18,1) = 0;II(18,2)=1;%mu
p_18 = [1,0.11,0.04];

II(19,1) = 0;II(19,2)=1;%gamma
p_19 = [1,0.975,0.01];

II(20,1) = 0;II(20,2)=1;%we
p_20 = [1,0.02,0.007];

II(21,1) = 0;II(21,2)=1;%bigtheta 
p_21 = [1,0.02,0.007];


%----------------------------------------------

%----- NOTE: Normally, only the above parameters would be selected for estimation
%            The remaining parameters are specified in 'setup.m'. They cannot be
%            estimated for the time being as they affect the steady state and the program is not ready for that

norestrictions=0; %=1, undo the restrictions. This is sometimes helpful (e.g. when you want to compute Hessian). 
                  %=0 otherwise