%this is the beginning of a program to generate simulations of the model, and impulse response functions.
%the first step is to go get a model parameterization and solution. This is done by getandcheck. 
%the 'model' now is the following...
%  z(t)=A*z(t-1)+B*s(t), where s(t) = [psi(t),psi(t-1)], and psi is CAPITALIZED psi in the text.
%also, s(t)=P*s(t-1) + shock(t).

clear all
%close all
dbstop in plotresponses at 11
dbstop if error

load wherearewe 

getandcheck;

bb=0;
if entr == 2
    bb=1;
    entr=1;
    params(1)=1;
elseif entr == -4
    bb=1;
    entr=-3;
    params(1)=-3;
end

Time1 =30; %number of periods used in plotting impulse responses


Time = max(Time1,2*max(parstoch(taushock)));
buffer = 2; %the model is simulated for a higher number of periods than the one specified in Time above. This accommodates the need for constructing the expectation of some variables at the last period of 'Time'  (e.g. when constructing the wedges and real interest rate)
Time =Time+max(duration1,buffer); %we need this in order to construct the long-term interest rate

if entr ==0  %we have made a change of variable in makealphabeta in order to impose information restrictions. We have now to undo the change
    Q = eye(nn);
    if size(Q,1)>size(A,1) || size(Q,1)<size(A,1)
        error('the size of Q and A is different')
    end
    Q(18,18) = 1-alpha;
    Q(18,8) = 1;
    QI=inv(Q);  
end

%simulate the model
[vbname,signal_on,II,III] = findnum(taushock,parstoch,length(rho),shockss);

for ij=1:length(taushock)
    eps0 = zeros(size(D,1),Time);

    if (parstoch(taushock(ij))) == 0
		txt = 1;
        eps0(II(ij),1) = stdshocks1(taushock(ij));  %%%%%%%%%%%%%%%%%%%%%%
    else 
        showsignals_ = 4; %=1, at time t agents receive a patriot, and a signal about value at t+1, a signal about value at t+2, ..., signal about value at t+parstoch
                          %=2, at time t agents receive signal about value at t+parstoch; at t+1 a new signal about value at t+parstoch; at t+2 a new signal about value at t+parstoch; ..., at t+parstoch-1 a new signal about value at t+parstoch; at t+parstoch there is a patriot
                          %=3, at time t agents receive signal about value at t+parstoch
                          %=4, at time t, patriot (this corresponds to standard IRF)
        txt = parstoch(taushock(ij))+1;
        if showsignals_ ==1
            eps0(II(ij),1) = stdshocks1(taushock(ij));  %%%%%%%%%%%%%%%%%%%%%%
            eps0(II(ij)+2:II(ij)+1+parstoch(taushock(ij)),1) = stdshocks2(taushock(ij));  %%%%%%%%%%%%%%%%%%%%%%%
        elseif showsignals_ ==2
            for jk=1:parstoch(taushock(ij))
                eps0(II(ij)+1+jk,jk) = stdshocks2(taushock(ij));
                if jk==parstoch(taushock(ij))
                    eps0(II(ij),jk+1) = stdshocks1(taushock(ij));
                end
            end
        elseif showsignals_ ==3
            eps0(II(ij)+1+1,1) = stdshocks2(taushock(ij)); %eps0(II(ij)+1+8,1) = stdshocks2(taushock(ij)); %
            
        elseif showsignals_ ==4
            eps0(II(ij),1) = stdshocks1(taushock(ij));  
        end
    end

    shock(:,1) = eps0(:,1);
    z1(:,1)    = B1*shock(:,1);
    if entr==0
        z1(:,1) = QI*z1(:,1);
    end

    for t=2:Time,
        shock(:,t)=rho*shock(:,t-1) + eps0(:,t);
        z1(:,t)=A*z1(:,t-1)+B1*shock(:,t);
        if entr ==0
           z1(:,t)=QI*z1(:,t);
        end
    end
    
    %unload the variables in z(t)
    if max(max(abs(imag(z1)))) > .1e-10
        error('fatal (simulate) simulated data complex')
    end
    z1=real(z1);

    %another check to verify the solution:
    if entr ~= 0
        Q=eye(size(alpha_0,1));
    end
    
    if max(parstoch) == 0
        err(:,1)=alpha_0*Q*z1(:,2)+alpha_1*Q*z1(:,1)+beta_0*shock(:,2)+beta_1*shock(:,1);
        for ii =2:Time-1
            err(:,ii)=alpha_0*Q*z1(:,ii+1)+alpha_1*Q*z1(:,ii)+alpha_2*Q*z1(:,ii-1) ...
                +beta_0*shock(:,ii+1)+beta_1*shock(:,ii);
        end
        if max(max(abs(err))) > .1e-10
            error('fatal (simulate) solution failed accuracy check')
        end
    end

    infhat=z1(1,[1:Time]);
    shat=z1(2,[1:Time]);
    rkhat=z1(3,[1:Time]);
    ihat=z1(4,[1:Time]);
    uhat=z1(5,[1:Time]);
    jj=5;
    if entr == 1 || entr==-3
        omhat=z1(jj+1,[1:Time]);
        jj=jj+1;
    end
    Rkhat=z1(jj+1,[1:Time]);
    if entr == 1 || entr==-3
        nhatp=z1(jj+2,[1:Time]);
        nhat=[0 nhatp([1:Time-1])];%nhat, beginning of period t
        jj=jj+2;
    else
        nhatp=[];
        jj=jj+1;
    end
    qhat=z1(jj+1,[1:Time]);
    qm1hat=[0 qhat([1:Time-1])];%qhat, period t-1 (needed for external finance premium)
    if entr ==1 || entr==0
        vlhat=z1(jj+2,[1:Time]);
        evhat=z1(jj+3,[1:Time]);
        jj=jj+3;
    else
        jj=jj+1;
    end
    if entr > -2
        mbhatp = z1(jj+1,[1:Time]); %mb(t+1)
        mbhat = [0 mbhatp([1:Time-1])]; %this is mb(t)
        jj=jj+1;
    end
    if entr~= -3
       Rhat=z1(jj+1,[1:Time]);
       jj=jj+1;
    end
    uzchat=z1(jj+1,[1:Time]);
    jj=jj+1;
    if entr ~= -2
        lamzhat=z1(jj+1,[1:Time]);
        jj=jj+1;
    end
    if entr >= -1
        mhat=z1(jj+1,[1:Time]);
        jj=jj+1;
    end
    if entr >=0
        Rahat=z1(jj+1,[1:Time]);
        jj=jj+1;
    end

    chat=z1(jj+1,[1:Time]);
    what=z1(jj+2,[1:Time]);
    lhat=z1(jj+3,[1:Time]);
    kbhatp=z1(jj+4,[1:Time]);%kbar(t+1)
    kbhat=[0 kbhatp([1:Time-1])];%convert to kbar(t)
    jj=jj+4;
    if entr >= 0 || entr==-3
        if bb == 0
        Rehatp=z1(jj+1,[1:Time]);%this is Re(t+1)
        Rehat=[0 Rehatp([1:Time-1])]; %this is Re(t)
        elseif bb == 1
            Fhatp=z1(jj+1,[1:Time]);%this is F(t+1)
            Fhat=[0 Fhatp([1:Time-1])]; %this is F(t)
            Rehat=((1+Re)/Re)*(Fhat+infhat);
            Rehatp=[Rehat(2:Time) 0];
        end        
        jj=jj+1;
    end
    if entr >= -1
        xhat=z1(jj+1,[1:Time]);
        jj=jj+1;
    end
    if entr == 1 || entr==0
        dmhatp=z1(jj+1,[1:Time]); %this is dm(t+1)
        dmhat=[0 dmhatp([1:Time-1])]; %convert to dm(t)
        Rmhatp=z1(jj+2,[1:Time]); %this is Rm(t+1)
        Rmhat=[0 Rmhatp([1:Time-1])]; %this is Rm(t)
        m3hat=z1(jj+3,[1:Time]);
        %jj+1= mb lagged
        jj=jj+4;
    end
    if entr ==1 || entr==-3 || entr==2
        btothat=z1(jj+1,[1:Time]);
        jj=jj+1;
        if entr==1
            jj=jj+1; %k lagged
        end
    end
    Ehat=z1(jj+1,1:Time);
    jj = jj+1;
    if do_qavrg ==1
      qavrghat=z1(jj+1,1:Time);
    end

    %unload shocks
    lambdafhat=zeros(1,Time);
    tauhat=zeros(1,Time);
    psilhat=zeros(1,Time);
    psikhat=zeros(1,Time);
    ksihat=zeros(1,Time);
    xbhat=zeros(1,Time);
    muuphat=zeros(1,Time);
    chihat=zeros(1,Time);
    ghat=zeros(1,Time);
    taulhat=zeros(1,Time);
    taukhat=zeros(1,Time);
    zetahat=zeros(1,Time);
    vhat = zeros(1,Time);
    tauDhat = zeros(1,Time);
    muzhat=zeros(1,Time);
    gammahat =zeros(1,Time);
    epsilonhat = zeros(1,Time);
    xphat = zeros(1,Time);
    tauChat = zeros(1,Time);
    sigmahat=zeros(1,Time);
    sigmahatm1 =zeros(1,Time); %sigmahat(t-1)
    zetachat=zeros(1,Time);
    zetaihat=zeros(1,Time);
    tauohat=zeros(1,Time);
    termhat=zeros(1,Time);
    

    String=['Path followed by the shock in ' texlabel(nameshocks(taushock(ij),:))];
    if taushock(ij) ==1
        lambdafhat = shock(II(ij),1:Time);
        figure;plot(lambdafhat);title(String);
    elseif taushock(ij) == 2
        tauhat=shock(II(ij),1:Time);
        figure;plot(tauhat);title(String);
    elseif taushock(ij) ==3
        psilhat=shock(II(ij),1:Time);
        figure;plot(psilhat);title(String);
    elseif taushock(ij) == 4
        psikhat=shock(II(ij),1:Time);
        figure;plot(psikhat);title(String);
    elseif taushock(ij) == 5
        ksihat= shock(II(ij),1:Time);
        figure;plot(ksihat);title(String);
    elseif taushock(ij) == 6
        xbhat=shock(II(ij),1:Time);
        figure;plot(xbhat);title(String);
    elseif taushock(ij) == 7
        muuphat=shock(II(ij),1:Time);
        figure;plot(muuphat);title(String);
    elseif taushock(ij) ==8
        thetahat=shock(II(ij),1:Time);
        figure;plot(thetahat);title(String);
    elseif taushock(ij) == 9
        chihat=shock(II(ij),1:Time);
        figure;plot(chihat);title(String);
    elseif taushock(ij) ==10
        taulhat = shock(II(ij),1:Time);
        figure;plot(taulhat);title(String);
    elseif taushock(ij) == 11
        taukhat = shock(II(ij),1:Time);
        figure;plot(taukhat);title(String);
    elseif taushock(ij) == 12
        zetahat=shock(II(ij),1:Time);
        figure;plot(zetahat);title(String);
    elseif taushock(ij) == 13
        ghat=shock(II(ij),1:Time);
        figure;plot(ghat);title(String);
    elseif taushock(ij) == 14
        vhat = shock(II(ij),1:Time);
        figure;plot(vhat);title(String);
    elseif taushock(ij) == 15
        tauDhat = shock(II(ij),1:Time);
        figure;plot(tauDhat);title(String);
    elseif taushock(ij)==16
        muzhat=shock(II(ij),1:Time);
        figure;plot(muzhat);title(String);
    elseif taushock(ij) == 17
        gammahat = shock(II(ij),1:Time);
        figure;plot(gammahat);title(String);
    elseif taushock(ij) == 18
        epsilonhat = shock(II(ij),1:Time);
        figure;plot(epsilonhat);title(String);
    elseif taushock(ij) == 19
        xphat = shock(II(ij),1:Time);
        figure;plot(xphat);title(String);
    elseif taushock(ij) == 20
        tauChat = shock(II(ij),1:Time);
        figure;plot(tauChat);title(String);
    elseif taushock(ij) == 21
        sigmahat=shock(II(ij),1:Time);
        sigmahatm1=[shock(II(ij)+1,1:Time)];
        figure;plot(sigmahatm1);title(String);
    elseif taushock(ij) == 22
        zetachat = shock(II(ij),1:Time);
        figure;plot(zetachat);title(String);
    elseif taushock(ij) == 23
        zetaihat = shock(II(ij),1:Time);
        figure;plot(zetaihat);title(String);
    elseif taushock(ij) == 24
        tauohat = shock(II(ij),1:Time);
        figure;plot(tauohat);title(String);
    elseif taushock(ij) == 25
        termhat = shock(II(ij),1:Time);
        figure;plot(termhat);title(String);
    end

    muzstart=muzstar*(muzhat+1);
    zt(1)     = muzstart(1); %this is z*(t)
    zbt(1)    = muzstar;
    upsilt(1) = upsil;
    for t=2:Time
        zt(t)     = zt(t-1)*muzstart(t);
        zbt(t)    = zbt(t-1)*muzstar;
        upsilt(t) = upsilt(t-1)*upsil;
    end
     
    if entr == -2
        lamzhat=uzchat-zetachat-(tauc/(1+tauc))*tauChat;
    end
   
    %construct output
    yhat = (g/y).*ghat+(c/y).*chat+(i/y).*ihat-(i/y).*muuphat; %goods output, exluding goods used in monitoring
    tab = [yhat' chat' ihat'];
    rr=yhat-(c/y)*chat-(i/y)*ihat;


    if entr==1 || entr==-3
        d       =   mu*kbar*(1+Rk)*G/(pi*muzstar);
    elseif entr==0 || entr==-1 || entr==-2
        d        = 0;
        bigtheta = 0;
    end

    %   this is for diagnostic purposes
    %   it checks that the resource constraint is satisfied, but
    %   works best when the only shock is epsilon
    cccheck=1;
    if cccheck == 1

        c_y     =   c/(y+phi+d+(1-gamma)*bigtheta*vn);
        g_y     =   g/(y+phi+d+(1-gamma)*bigtheta*vn);
        d_y     =   d/(y+phi+d+(1-gamma)*bigtheta*vn);
        v_y     =   vn/(y+phi+d+(1-gamma)*bigtheta*vn);
        u_y     =   (rk*kbar/(muzstar*upsil))/(y+phi+d+(1-gamma)*bigtheta*vn);
        kbar_y  =   kbar/(y+phi+d+(1-gamma)*bigtheta*vn);

        if entr == 1

            yshat = (alpha*(uhat - muzhat + kbhat + vlhat) + (1-alpha)*(lhat + vlhat) ...
                + epsilonhat - d_y*( (Gp/G)*omegabar*omhat + (Gs/G)*sigma*sigmahatm1 ...
                + (Rk/(1+Rk))*Rkhat + qm1hat + kbhat - muzhat - infhat) ...
                - u_y*uhat - bigtheta*(1-gamma)*v_y*(-gammahat + n*nhatp/(n-we)) ...
                + bigtheta*gamma*v_y*gammahat);

            yhatp = (g_y*ghat+c_y*chat+kbar_y*(i/kbar)*ihat-kbar_y*(i/kbar)*muuphat);

            res=yshat-yhatp;

            %this check works, regardless of how many shocks there are
            if max(abs(res)) >.1e-10
                error('fatal (simulate) resource constraint not satisfied')
            end

            ydid=100*(alpha*(uhat - muzhat + kbhat + vlhat) + (1-alpha)*(lhat + vlhat) ...
                + epsilonhat)*(y+phi+d+(1-gamma)*bigtheta*vn)/y;

            %this check works only if the only shock is epsilon
            if length(taushock) == 1
                if taushock == 18
                    resss = alpha_1(11,4)*ihat+alpha_1(11,5)*uhat+alpha_1(11,18)*chat ...
                        +alpha_1(11,20)*lhat+alpha_2(11,21)*kbhat + beta_1(11,1)*epsilonhat ...
                        +alpha_1(11,6)*omhat+alpha_1(11,1)*infhat+alpha_1(11,7)*Rkhat ...
                        +alpha_2(11,9)*qm1hat+alpha_1(11,8)*nhatp+alpha_1(11,10)*vlhat;
                    if max(abs(resss)) > .1e-10
                        error('fatal (simulate) resource constraint not satisfied')
                    end
                end
            end

            ezr(1)=(alpha-u_y) + alpha_1(11,5);%uhat
            ezr(2)=(alpha-d_y) + alpha_2(11,21);%kbhat
            ezr(3)= 1 + alpha_1(11,10);%vlhat
            ezr(4)= (1-alpha) + alpha_1(11,20);%lhat
            ezr(5)= -d_y*(Gp/G)*omegabar+alpha_1(11,6);%omhat
            ezr(6)= -d_y*(Rk/(1+Rk))+alpha_1(11,7);%Rkhat
            ezr(7)= -d_y + alpha_2(11,9);%qm1hat
            ezr(8)= d_y + alpha_1(11,1);%infhat
            ezr(9) = - bigtheta*(1-gamma)*v_y*n/(n-we) + alpha_1(11,8);%nhatp
            ezr(10) = c_y-alpha_1(11,18);%chat
            ezr(11) = kbar_y*(i/kbar)-alpha_1(11,4);%ihat
            ezr(12)= 1 + beta_1(11,1);%epsilon

            if max(abs(ezr([1:11]))) > .1e-10
                error('fatal (simulate) problem with alpha''s associated with resource constraint')
            end
            if length(taushock) == 1
                if taushock == 18
                    if abs(ezr(12)) > .1e-10
                        error('fatal (simulate) problem with beta''s associated with resource constraint')
                    end
                end
            end

        elseif entr == 0

            yshat = (alpha*(uhat - muzhat + kbhat + vlhat) + (1-alpha)*(lhat + vlhat) ...
                + epsilonhat - u_y*uhat)*(y+phi+d+(1-gamma)*bigtheta*vn)/y;

            ydid=100*(alpha*(uhat - muzhat + kbhat + vlhat) + (1-alpha)*(lhat + vlhat) ...
                + epsilonhat)*(y+phi+d+(1-gamma)*bigtheta*vn)/y;

            res = yshat - yhat;

            if max(abs(res)) > .1e-10
                error('fatal (simulate) resource constraint not satisfied')
            end

        elseif entr == -2

            yshat = (alpha*(uhat - muzhat + kbhat) + (1-alpha)*lhat ...
                + epsilonhat - u_y*uhat)*(y+phi+d+(1-gamma)*bigtheta*vn)/y;

            ydid=100*(alpha*(uhat - muzhat + kbhat) + (1-alpha)*(lhat) ...
                + epsilonhat)*(y+phi+d+(1-gamma)*bigtheta*vn)/y;

            res = yshat - yhat;

            if max(abs(res)) > .1e-10
                error('fatal (simulate) resource constraint not satisfied')
            end

        end

    end
    
    if entr >= 0
        %construct long-term interest rate
        for jij=1:(Time-duration1)
            Rlong(jij) = (1/duration1)*sum(Rehatp(jij:jij+duration1-1));
        end
        Rlong = [Rlong zeros(1,duration1)];
    end

    % construct TFP
    rkt      = (rkhat+1)*rk;
    labort   = l*(lhat+1);
    waget    = w*(what+1);
    capitalt = (uhat+1).*kbar.*(kbhat+1); %capital services
    physicap = kbar.*(kbhat+1);
    outputt  = y*(yhat+1);
    sharekt  = (1/Time)*sum(rkt(1:Time).*capitalt(1:Time)./(outputt(1:Time).*muzstart(1:Time).*upsil)); %average capital share
    sharelt  = (1/Time)*sum(waget(1:Time).*labort(1:Time)./outputt(1:Time));
    dent     = ((upsilt.*physicap./(muzstart*upsil)).^sharekt).*(labort.^sharelt);
    TFPt     = ((zt.^(1-sharekt)).*outputt)./dent;
    sharek   = rk*kbar/(y*muzstar*upsil);
    sharel   = w*l/y;
    den      = ((upsilt.*kbar./(muzstar*upsil)).^sharek).*(l.^sharel);
    TFP      = ((zbt.^(1-sharek)).*y)./den;
    TFPhat   = (TFPt-TFP)./TFP;

    labour_share=waget(1:Time).*labort(1:Time)./outputt(1:Time);
    labour_sharehat=(labour_share - (w*l/y))./(w*l/y);
    cap_share=rkt(1:Time).*capitalt(1:Time)./(outputt(1:Time).*muzstart(1:Time).*upsil);
    cap_share_bar=rk*k/(y*muzstar*upsil);
    cap_sharehat=(cap_share-cap_share_bar)./cap_share_bar;

    % construct money-tax wedge
    ct = (chat+1)*c; %consumption(t)
    ctp1 = [ct(2:end) 0]; %consumption(t+1)
    ctm1 = [c ct(1:end-1)]; %consumption(t-1)
    muzstarhatp1 = [muzhat(2:end) 0];
    mucont = ((muzhat+1).*muzstar)./( ct.*((muzhat+1).*muzstar) -b.*ctm1 ) - (b*beta)./( ctp1.*((muzstarhatp1+1).*muzstar) -b*ct); %marginal utility of consumption
    mucon  = (muzstar-b*beta)/(c*muzstar-b*c);
    wedge_moneyt = (lamzhat+1).*lambdaz - mucont ;
    wedge_money  = lambdaz - mucon;
    wedge_moneyhat = (wedge_moneyt - wedge_money)./wedge_money;

    %construct labor-tax wedge
    wedge_labort = (what+1)*w + (psiL*((lhat+1)*l).^sigmaL)./( mucont + wedge_moneyt );
    wedge_labor  = w + (psiL*(l)^sigmaL) /( mucon + wedge_money );
    wedge_laborhat = (wedge_labort - wedge_labor)./wedge_labor;

    %construct firm wedge
    wedge_firmt = sharelt.*((physicap./(upsil.*(muzhat+1).*muzstar)).^sharekt).*(labort.^(sharelt-1)) - waget;
    wedge_firm  = sharel* ((k/(upsil*muzstar))^sharek) *(l^(sharel-1)) - w;
    wedge_firmhat = (wedge_firmt - wedge_firm)./wedge_firm;

    %construct capital-income-tax wedge
    mucontp1 = [mucont(2:end) 0];
    wedge_moneytp1 = [wedge_moneyt(2:end) 0];
    wedge_capitalt = wedge_moneyt + mucont - (beta./((muzstarhatp1+1).*muzstar)).*( wedge_moneytp1 + mucontp1 ).*( sharekt.*((physicap./((muzhat+1).*muzstar)).^(sharekt-1)).*labort.^sharelt +1-delta);
    wedge_capital = wedge_money + mucon - (beta/muzstar)*(wedge_money +mucon)*(sharek*((k/muzstar)^(sharek-1)*l^sharel)  +1-delta );
    wedge_capitalhat = (wedge_capitalt - wedge_capital)./wedge_capital;

    if entr ==1 || entr==-3
        premium=mu*G*(1+Rk)*k/(k-n);
        premiumhat = (Gp*omegabar/G)*omhat + (Gs*sigma/G)*sigmahatm1 + (Rk/(1+Rk))*Rkhat + qm1hat + kbhat - (1/(k-n))*( k*(qm1hat + kbhat) - n*nhat);

        Z=omegabar*(1+Rk)*k/(k-n);
        Zhat=omhat+(Rk/(1+Rk))*Rkhat+qm1hat+kbhat-(k/(k-n))*(kbhat+qm1hat)+(n/(k-n))*nhat;

        entret_loans=(qm1hat+1).*kbar.*(kbhat+1)-((nhat+1).*n); %entrep. loans scaled by P(t-1)z*(t-1)
        entre_loans_ss = kbar-n;
        entret_loans_hat = (entret_loans - entre_loans_ss*ones(1,Time)) ./entre_loans_ss;
        entret_loans_hat_pz = entret_loans_hat - infhat -muzhat; %entrepr. loans scaled by P(t)z*(t)
        
        Lvrg_e_ss = (q*kbar-n)/n; %Borrowing/N
        Lvrg_e_hat = (q*kbar/(q*kbar-n)) * ( qhat+kbhatp-nhatp);
        
        Lvrg_a_ss = (q*kbar-n)/(q*kbar); %Borrowing/qk
        Lvrg_a_hat = n/(q*kbar-n) * ( qhat+kbhatp-nhatp );
        
        n_y_hat =  nhatp - yhat;  %N/(PY)
        b_y_hat =  q*kbar/(q*kbar-n) * (qhat + kbhatp) - n/(q*kbar-n)*nhatp -yhat;  %Borrowing/(PY)
         
        opt = 1;
        bhat = (kbar/(kbar-n))*(qhat + kbhatp) - (n/(kbar-n))*nhatp;
        
        %edf*[sigma-hat Zp1-hat Rkp1-hat Rep1-hat (q-hat+kp1-hat - np1hat) Petil-hat]' 
%         for t = 1:Time-1
%             if opt == 1
%                 err(:,t)=edf*[sigmahat(t) omhat(t+1) Rkhat(t+1) Rehatp(t) (qhat(t) + kbhatp(t) - nhatp(t)) premiumhat(t+1)]';
%             else
%                 err(:,t)=edf*[sigmahat(t) Zhat(t+1) Rkhat(t+1) Rehatp(t) (qhat(t) + kbhatp(t) - nhatp(t)) premiumhat(t+1)]';
%             end
%         end

        probss=logncdf(omegabar,-sigma^2/2,sigma); %compute probability of bankruptcy
        for t = 1:Time
            omegat=(omhat(t)+1)*omegabar;
            sigmat = (sigmahatm1(t)+1)*sigma;
            if abs(imag(omegat)) < .1e-10; omegat=real(omegat);end
            prob(t)=logncdf(omegat,-sigmat^2/2,sigmat)-probss;
        end
    end
    if entr==1 
        dc=m/(1-m+dm+(psil*w*l*pi*muzstar/mb)+psik*rk*kbar*pi/(upsil*mb)); %this is currency to deposits
        dchat=mhat+dc*mhat-(dc*dm/m)*dmhat- (dc*psil*w*l*pi*muzstar/(m*mb))*(psilhat + what - mbhat ...
            + lhat + infhat + muzhat )-(dc*psik*rk*k*pi/(m*upsil*mb))*(psikhat+rkhat+uhat+kbhat-mbhat + infhat);

        herhat= -( (1/(1-ksi))+log(ev) )*ksi*ksihat+xbhat-ksi*evhat;

        Rbhat=Rhat+herhat-(tau*her/(tau*her+1))*(herhat+tauhat);

        mbt=(mbhat+1)*mb;
        velbase=y*pi*muzstar/mb;
        for is = 1:Time
            velbaset(is)=outputt(is)*pi*(infhat(is)+1)*muzstar*(muzhat(is)+1)./(mbt(is));
            velbasehat(is)=(velbaset(is)-velbase)/velbase;
        end

        mt=(mhat+1)*m;
        xt=(xhat+1)*x;
        %     MbMbbar(1)=1;
        %     for ff = 1:Time-1
        %         MbMbbar(ff+1)=1;
        %         for hh = 1:ff
        %             MbMbbar(ff+1)=MbMbbar(ff+1)*(1+xt(hh))/(1+x);
        %         end
        %     end
        %
        %     dM=(MbMbbar.*(m*(mhat+1)) - m)./ ( MbMbbar.*(1+xt) - (1+x) );
        %     dRe=(MbMbbar.*(1 - m*(mhat+1) + xt) - (1 - m + x))./ ( MbMbbar.*(1+xt) - (1+x) );
        %
        psilt=(psilhat+1)*psil;
        psikt=(psikhat+1)*psik;
        working=psil*w*l+psik*rk*kbar/(muzstar*upsil);
        workingt=psilt.*w.*(what+1).*l.*(lhat+1)+psikt.*rkt.*(uhat+1).*kbar.*(kbhat+1)./(upsil*muzstar*(muzhat+1));

        %m1=mb/(pi*muzstar) +psil*w*l+psik*rk*kbar/(muzstar*upsil);
        m1t=mbt./((pi*(infhat+1)).*(muzstar*(muzhat+1))) + workingt;
        m1hat= (m1t-m1)/m1;

        velm1t=outputt./m1t;
        velm1=y/m1;
        velm1hat=(velm1t-velm1)/velm1;

        m3t=(m3hat+1)*m3;
        velm3t=outputt./m3t;
        velm3=y/m3;
        velm3hat=(velm3t-velm3)/velm3;

        timedept = (qm1hat+1).*kbar.*(kbhat+1)-(nhat+1)*n - dm.*(dmhat+1).*mb.*(mbhat+1);%time deposits, scaled by P(t-1)z(t-1).
        timedepss = kbar-n-dm*mb; %time deposits, scaled by P(t-1)z(t-1).
        %timedephat = (timedept - timedepss*ones(1,Time))./timedepss;
        timedephat = k/timedepss*(qm1hat+kbhat)-n/timedepss*nhat-dm*mb/timedepss*(dmhat+mbhat);
        %timedephat_pz = timedephat - infhat -muzhat; %time deposits scaled by P(t)z(t)
        timedephat_pz = k/timedepss*(qhat+kbhatp)-n/timedepss*nhatp-dm*mb/timedepss*(dmhatp+mbhatp);
                

        Dht=(mbt./(muzstar*(muzhat+1).*pi.*(infhat+1))).*(1-mt); %household demand deposits, scaled by P(t)z(t)
        Dhss=(mb/(pi*muzstar))*(1-m);%household demand deposits (Dh(t)), scaled by P(t)z(t)
        Dhhat = (Dht - Dhss*ones(1,Time))./Dhss;
        Dhss =mb*(1-m); %Dh(t+1)
        Dhhat = mb*(1-m)/Dhss*mbhatp - mb/Dhss*m/(1-m)*[mhat(2:end) 0]; %end of period

        currencyt=(mbt./(muzstar*(muzhat+1).*pi.*(infhat+1))).*mt; %household currency decision, scaled by P(t)z(t)
        currencyss=(mb/(pi*muzstar))*m;%household currency decision, scaled by P(t)z(t)
        currencyhat = (currencyt - currencyss*ones(1,Time))./currencyss;

        dmt=(dmhat+1)*dm;
        Dmt =dmt.*(mbt./(muzstar*(muzhat+1).*pi.*(infhat+1))); %this is Dm(t) scaled by P(t)z(t)
        %Dmhat= (Dmt-dm*mb/(pi*muzstar))/(dm*mb/(pi*muzstar));
        Dmhat = dmhat+mbhat-infhat-muzhat ; %beginning-of-period
        Dmhat = dmhatp+mbhatp; %end-of-period

        gm1(1)=(muzstar*(muzhat(1)+1).*pi.*(infhat(1)+1))*m1t(1)/m1;
        for is = 2:Time
            gm1(is)=(muzstar*(muzhat(is)+1).*pi.*(infhat(is)+1))*m1t(is)/m1t(is-1);
        end
        gres(1)= mbt(1).*(1-mt(1))/((mb/(pi*muzstar))*(1-m));
        for is = 2:Time
            gres(is)=mbt(is).*(1-mt(is))/ (  (mbt(is-1)./(muzstar*(muzhat(is-1)+1).*pi.*(infhat(is-1)+1)))  .*(1-mt(is-1)));
        end
        gwork(1)=(muzstar*(muzhat(1)+1).*pi.*(infhat(1)+1))*workingt(1)/working;
        for is = 2:Time
            gwork(is)=(muzstar*(muzhat(is)+1).*pi.*(infhat(is)+1))*workingt(is)/workingt(is-1);
        end
        gm3(1)=(muzstar*(muzhat(1)+1).*pi.*(infhat(1)+1))*m3t(1)/m3;
        for is = 2:Time
            gm3(is)=(muzstar*(muzhat(is)+1).*pi.*(infhat(is)+1))*m3t(is)/m3t(is-1);
        end

        check=0;
        if check == 1
            figure
            subplot(321)
            plot(100*(gm1.^4-1))
            title('M1 growth')
            subplot(322)
            plot(100*(gres.^4-1))
            title('Bank Reserves Growth')
            subplot(323)
            plot(100*((1+xt).^4-1))
            title('Base growth')
            subplot(324)
            plot(100*(gm3.^4-1))
            title('M3 Growth')
            subplot(325)
            plot(100*(gwork.^4-1))
            title('Growth of Working Capital Loans')
        end

        decompose_Dm3 =0; %decomposition of nominal M3-hat growth
        if decompose_Dm3 ==1
            figure
            Dmb(1) = mbhat(1);
            Dm3(1) = m3hat(1);
            Dx(1)  = xhat(1);
            Ddm(1) = dmhat(1);
            Dw(1)  = what(1);
            Dl(1)  = lhat(1);
            Drk(1) = rkhat(1);
            Du(1)  = uhat(1);
            Dk(1)  = kbhat(1);
            for is = 2:Time
                Dmb(is)= mbhat(is) - mbhat(is-1);
                Dm3(is) = m3hat(is) - m3hat(is-1);
                Dx(is)  = xhat(is) - xhat(is-1);
                Ddm(is) = dmhat(is) - dmhat(is-1);
                Dw(is)  = what(is) - what(is-1);
                Dl(is)  = lhat(is) - lhat(is-1);
                Drk(is) = rkhat(is) - rkhat(is-1);
                Du(is)  = uhat(is) - uhat(is-1);
                Dk(is)  = kbhat(is) - kbhat(is-1);
            end
            subplot(5,2,1)
            plot(Dm3+infhat+muzhat)
            title('Nominal M3_hat growth')
            subplot(5,2,2)
            plot((mb*(1+dm)/(m3*pi*muzstar))*Dmb)
            title('Real Base_hat growth')
            subplot(5,2,3)
            title('x_hat growth')
            subplot(5,2,4)
            plot((mb*dm/(m3*pi*muzstar))*Ddm)
            title('Dm/Mb_hat growth')
            subplot(5,2,5)
            plot((psil*w*l/m3)*Dw)
            title('w/p_hat growth')
            subplot(5,2,6)
            plot((psil*w*l/m3)*Dl)
            title('l_hat growth')
            subplot(5,2,7)
            plot((psik*rk*k/(muzstar*upsil*m3))*Drk)
            title('rk_hat growth')
            subplot(5,2,8)
            plot((psik*rk*k/(muzstar*upsil*m3))*Du)
            title('u_hat growth')
            subplot(5,2,9)
            plot((psik*rk*k/(muzstar*upsil*m3))*Dk)
            title('k_hat growth')
            subplot(5,2,10)
            plot(-(mb*(1+dm)/(m3*pi*muzstar))*infhat)
            title('inflation')
            hout=suptitle(['Contributions to nominal M3hat growth']);
        end

        bankassetst= (mbt./(muzstar*(muzhat+1).*pi.*(infhat+1))) .*(1-mt)+psilt.*w.*(what+1).*l.*(lhat+1)+psikt.*rkt.*(uhat+1).*kbar.*(kbhat+1)./(upsil*muzstar*(muzhat+1)) ...
            +((qm1hat+1).*kbar.*(kbhat+1)-((nhat+1)*n))./(muzstar*(muzhat+1).*pi.*(infhat+1));
        babyassets= (mbt./(muzstar*(muzhat+1).*pi.*(infhat+1))) .*(1-mt)+psilt.*w.*(what+1).*l.*(lhat+1)+psikt.*rkt.*(uhat+1).*kbar.*(kbhat+1)./(upsil*muzstar*(muzhat+1));
        workingcapt=workingt./babyassets;
%         entret_loans=(qm1hat+1).*kbar.*(kbhat+1)-((nhat+1).*n); %entrep. loans scaled by P(t-1)z*(t-1)
%         entre_loans_ss = kbar-n;
%         entret_loans_hat = (entret_loans - entre_loans_ss*ones(1,Time)) ./entre_loans_ss;
%         entret_loans_hat_pz = entret_loans_hat - infhat -muzhat; %entrepr. loans scaled by P(t)z*(t)

        entret_bank=(entret_loans./bankassetst)./(muzstar*(muzhat+1).*pi.*(infhat+1));
        reservest=(mbt./(muzstar*(muzhat+1).*pi.*(infhat+1))) .*(1-mt)./babyassets;
        ereservest=(1-tau.*(tauhat+1)).*(mbt./(muzstar*(muzhat+1).*pi.*(infhat+1)))  .*(1-mt)- ...
            tau*(tauhat+1).*(psilt.*w.*(what+1).*l.*(lhat+1)+psikt.*rkt.*(uhat+1).*kbar.*(kbhat+1)./(upsil*muzstar*(muzhat+1)) );
        ereservest=ereservest./babyassets;

        total_loanst=workingt + entret_loans./(muzstar*(muzhat+1).*pi.*(infhat+1)); %total loans scaled by P(t)z*(t)
        total_loans_ss = psil*w*l + psik*rk*kbar/(upsil*muzstar) + entre_loans_ss./(pi*muzstar);
        total_loans_hat= (total_loanst - total_loans_ss*ones(1,Time)) ./ total_loans_ss;
    end

    %construct (X(t)-Xbar(t))/Xbar(t), where X(t) is the value of a variable along
    %a perturbed path, and Xbar(t) is the value of the same variable along a steady state path.
    cshck(1)=muzhat(1)+1;
    ppi(1)=(1+infhat(1)); %construct the price level in deviation from the determinist trend in nominal variables (i.e. P(t)/P_steadystate_trend))
    for jj = 2:Time
        cshck(jj)=cshck(jj-1)*(muzhat(jj)+1);
        ppi(jj)=ppi(jj-1)*(1+infhat(jj));
    end 
    cuminfl=ppi; %we have defined the price level as ppi and in other places as cuminfl

    for jj = 1:Time
        C(jj)=((1+chat(jj))*cshck(jj))-1;
        I(jj)=((1+ihat(jj))*cshck(jj))-1;
        kbart(jj)=((1+kbhatp(jj))*cshck(jj))-1;
        Y(jj)=((1+yhat(jj))*cshck(jj))-1;
        Wage(jj)=((1+what(jj))*cshck(jj))-1; %real wage
        Wage_nominal(jj)=((1+what(jj))*cshck(jj)*ppi(jj))-1;
        if entr > -2
            Mb_real(jj)=((1+mbhatp(jj))*cshck(jj))-1; %real base
            Mb_nom(jj)=((1+mbhatp(jj))*cshck(jj)*ppi(jj))-1; %nominal base
        end
        if entr ==1 || entr==-3
            netp1(jj)=((1+nhatp(jj))*cshck(jj))-1;
            netp1_nominal(jj)=((1+nhatp(jj))*cshck(jj)*ppi(jj))-1;
            entre_loans_unscal_real(jj) = ((1+entret_loans_hat_pz(jj))*cshck(jj))-1;
        end
        if entr==1
            Dm_unscaled(jj)=((1+Dmhat(jj))*cshck(jj)*ppi(jj))-1; %Dm nominal
            total_loans_unscal_nom(jj) = ((1+total_loans_hat(jj))*cshck(jj)*ppi(jj))-1;
            total_loans_unscal_real(jj) = ((1+total_loans_hat(jj))*cshck(jj))-1;
            M1_real(jj)=((1+m1hat(jj))*cshck(jj))-1;  %real M1
            M1_nom(jj)=((1+m1hat(jj))*cshck(jj)*ppi(jj))-1; % nominal M1
            M3(jj)=((1+m3hat(jj))*cshck(jj)*ppi(jj))-1; %nominal M3
            M_nom(jj)=((1+currencyhat(jj))*cshck(jj)*ppi(jj))-1; %nominal currency
            timedep_nom(jj) = ((1+timedephat_pz(jj))*cshck(jj)*ppi(jj))-1; %nominal
            Dh_nom(jj) = ((1+Dhhat(jj))*cshck(jj)*ppi(jj))-1; %nominal
        end
    end

    if entr ==1
        %moneyinjection   %this file was written for the great depression paper. it has not been updated to make it consistent with the euro area setup

        if taushock(ij) == 16 | taushock(ij) == 19
            varimpulse   %plot impulse responses against the VAR for the US displayed in ACEL
        end
        if taushock(ij) == 19
            varimpulseeuroarea  %plot impulse responses against the VAR for the euro area produced by Angeloni, Kashyap and Mojon
        end
    end

    %plot results
    tt=1:(Time-max(buffer,duration1));
    String1=['Response to a shock in ' texlabel(nameshocks(taushock(ij),:))];
    
    if entr == -2
        Rehatp=Rhat;
        Re=R;
    end

    if doRBC >=1
        %compute RBC version of the model
        if ij ==1
            ind_rbc = 0;
            II_rbc =0;
        end
        lambdaff=lambdaf;
        lambdaww=lambdaw;
        [A_R,B1_R,out_R,inv_R,realrate_R,q_R,con_R,hours_R,wage_R,ind_rbc,II_rbc] = RBC(rho,D,pi,muzstar,beta,taud,tauk,upsil,delta,lambdaff,alpha,b,taul,tauc, ...
            lambdaww,zeta,psiL,etag,Sdoupr,sigmaa,sigmaL,taushock,nameshocks,parstoch,stdshocks1,stdshocks2,Time,cshck,String1,ind_rbc,II_rbc,ij,static,etai,util);
              
        if doRBC == 2
            legendstr1 = []; legendstr2 = [];
            String1 = [String1 ' Real Business Cycle Model'];
            
            realrate_RR = realrate_R*(muzstar/beta-1);

            doplot1(tt,pi,Pe,beta,muzstar,out_R,[],[],[],inv_R,[],q_R,[],con_R,[],wage_R,[],hours_R,[], ...
                  realrate_RR,[],[],[],String1,Re,txt,legendstr1,legendstr2);
            
            out_Rbase=out_R; inv_Rbase=inv_R; c_Rbase=con_R; l_Rbase=hours_R;real_Rbase=realrate_R;q_Rbase=q_R;wage_Rbase=wage_R;
            save([outfolder '\RBCdat'], 'out_Rbase', 'inv_Rbase', 'c_Rbase', 'l_Rbase', 'real_Rbase', 'q_Rbase', 'wage_Rbase');
            return
        end
        
        if doRBC == 3
            legendstr1 = 'Perturbed RBC Model';legendstr2 = 'Baseline RBC Model'; 
            String1 = [String1 ' Perturbated RBC Model (-) and Baseline RBC Model(o)'];
            load([outfolder '\RBCdat'])
            
            realrate_RR = realrate_R*(muzstar/beta-1);
            real_RRbase = real_Rbase*(muzstar/beta-1);
            
            doplot1(tt,pi,Pe,beta,muzstar,out_Rbase,out_R,[],[],inv_Rbase,inv_R,q_Rbase,q_R,c_Rbase,con_R,wage_Rbase,wage_R,l_Rbase,hours_R, ...
                  real_RRbase,realrate_RR,[],[],String1,Re,txt,legendstr1,legendstr2);
        end

        checkramsey=0;
        if checkramsey==1
            addpath d:\dynare_v3\matlab
            cd d:\banking\euroarea_code\stickypwhabit
            %[c_rms,h_rms,pi_rms,epsil_rms,Rreal_rms,R_rms,y_rms,w_rms,i_rms,q_rms] = newsimplemodel_out(tt, ...
        newsimplemodel_out(tt, ...
                lambdaw,sigmaL,zeta,beta,b,psiL,zetac,tauo, ...
                sigmaa,Sdoupr,etai,muup,zetai,lambdaf,alpha,psik,psil,delta,epsil,xip, ...
                x,aptil,aytil,rhotil,xiw);
            rmpath d:\dynare_v3\matlab
            cd ..
           
           legendstr1 = 'Ramsey Solution';legendstr2 = 'RBC Model'; 
           String1 = [String1 ' Ramsey Solution(-) and RBC(o)'];
        
           realrate_RR = realrate_R*(muzstar/beta-1);
           %realrate    = ( (Re/(1+Re))*Rehatp - [infhat(2:end) 0] )*muzstar/beta;
        
           doplot1(tt,pi,Pe,beta,muzstar,out_R,y_rms,[],pi_rms,inv_R,i_rms,q_R,q_rms,con_R,c_rms,wage_R,w_rms, ...
               hours_R,h_rms,realrate_RR,Rreal_rms,[],R_rms,String1,Re,txt,legendstr1,legendstr2);  
        end
        
        
        legendstr1 = 'Monetary Model';legendstr2 = 'RBC Model'; 
        String1 = [String1 ' Benchmark(-) and RBC(o)'];
        
        realrate_RR = realrate_R*(muzstar/beta-1);
        realrate    = ( (Re/(1+Re))*Rehatp - [infhat(2:end) 0] )*muzstar/beta;
        
        doplot1(tt,pi,Pe,beta,muzstar,out_R,Y,[],infhat,inv_R,I,q_R,qhat,con_R,C,wage_R,Wage,hours_R,lhat, ...
            realrate_RR,realrate,[],Rehatp,String1,Re,txt,legendstr1,legendstr2);
            
        if doRBC == 4   
            YCEEBase = Y; investCEEBase = I; consCEEBase = C;  wageCEEBase = Wage;  laborCEEBase = lhat;
            ReCEEBasep = Rehatp; qCEEBase = qhat;  inflCEEBase = infhat;
            save([outfolder '\CEEBase'], 'YCEEBase', 'consCEEBase', 'wageCEEBase', 'investCEEBase', 'laborCEEBase', 'ReCEEBasep', 'qCEEBase', 'inflCEEBase');
            disp('(simulate) just saved data for baseline CEE model, program now stops');
            return
        end
        
        if doRBC == 5
            load([outfolder '\CEEBase']);
            
            legendstr1 = 'Perturbed Monetary Model';legendstr2 = 'Baseline Monetary Model';           
            if entr==-2; String1 = 'Figure : Response of Simple Monetary Model and Perturbed Model to Signal Shock';end
            if entr==1;  String1 = 'Figure : Response of Full and Simple Monetary Model to Signal Shock';end
            if entr==2;  String1 = 'Figure : Response of Full (with no Debt-Deflation Effect) and Simple Monetary Model to Signal Shock';end
       
            realRCEE = ( (Re/(1+Re))*ReCEEBasep - [inflCEEBase(2:end) 0] )*muzstar/beta;
                    
            doplot1(tt,pi,Pe,beta,muzstar,YCEEBase,Y,inflCEEBase,infhat,investCEEBase,I,qCEEBase,qhat,consCEEBase,C, ...
                wageCEEBase,Wage,laborCEEBase,lhat, ...
                realRCEE,realrate,ReCEEBasep,Rehatp,String1,Re,txt,legendstr1,legendstr2);      
            
            if entr >= 1
                figure; orient landscape
                subplot(231)
                plot(tt,100*((1+xt(tt)).^4-1),'b-',txt,100*((1+xt(txt)).^4-1),'*')
                axis tight                
                title('Base growth (APR)')
                subplot(232)
                plot(tt,100*4*(gm1(tt)-1),'b-',txt,100*4*(gm1(txt)-1),'*')
                title('M1 growth (APR)')
                axis tight
                subplot(233)
                plot(tt,100*(gm3(tt).^4-1),txt,100*(gm3(txt).^4-1),'*')
                title('M3 Growth (APR)')
                axis tight
                subplot(234)
                gtotloans=400*(total_loans_hat+infhat+muzhat);
                plot(tt,gtotloans(tt),'b-',txt,gtotloans(txt),'*')
                title('Total credit growth (working capital loans and loans to entrepreneurs) (APR)')
                axis tight
                subplot(235)
                plot(tt,nhatp(tt)*100,'b-',txt,nhatp(txt)*100,'*')
                title('Net Worth');
                axis tight
                if entr==1;hout=suptitle('Figure : Behavior of Money and Credit in Full Monetary Model');end
                if entr==2;hout=suptitle('Figure : Behavior of Money and Credit in Full Monetary Model (no Debt-Deflation Effect)');end
                
            end
        end
    end

    if entr == 1
        %plot main variables
        if do_qavrg ==0
            qavrghat = [];
        end
           plotresponses(Y,I,C,uhat,lhat,Wage,infhat,pi,Rehatp,Re,qhat,qavrghat,netp1,premiumhat,Pe,total_loans_unscal_real,tt,String1);

        %plot variables related to entrepreneurs
        showentre(rkhat,rk,Rkhat,Rk,Rehatp,Re,Zhat,Z,premiumhat,Pe,omhat,prob,qhat,netp1,kbart,entre_loans_unscal_real,TFPhat,tt,String1);

        %plot variables related to banks
        plotbank(Mb_nom,M1_nom,M3,M_nom,Dh_nom,Dm_unscaled,timedep_nom,velm1hat,velm3hat,Rbhat,Rb,Rehatp,Re,Rahat,Ra,Rhat,R,Rmhatp,Rm, ...
            Zhat,Z,Rlong,tt,String1);

        %plot wedges
        plotwedges(TFPhat,wedge_moneyhat,wedge_laborhat,wedge_firmhat,wedge_capitalhat,tt,String1);

        %plot charts used in the note on the reference value for M3
        refvalue =0;
        if refvalue==1
            referencevalue(taushock,ij,tt,pi,beta,muzstar,out_R,Y,infhat,inv_R,I,con_R,C,hours_R,lhat,realrate_R,...
                M1_nom,M3,M_nom,Dm_unscaled,Rehatp,Re,Rmhatp,Rm);
        end

    end

    alternativemodels %it saves the results for the alternative models (ie. entre=1, entre=0, entre=-1) and plots them on the same chart
end