function [ffrk,q,u,pi,RT,Re,Rk,omegabar,Fomegabar,Gamma,G,n,k,i, ...
    w,l,y,phi,g,c,vn,uzc,lamz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl,costs,R] = steadysolve(rk,params,sigma)

ix=0;
Fomegabar   =   params(1);
mu          =   params(2);
x           =   params(3);
muzstar     =   params(4);
lambdaf     =   params(5);
lambdaw     =   params(6);
alpha       =   params(7);
psik        =   params(8);
psil        =   params(9);
delta       =   params(10);
tauk        =   params(11);
taul        =   params(12);
tauc        =   params(13);
gamma       =   params(14);
%l           =   params(15);
tauT        =   params(16);
tauD        =   params(17);
sigmaL      =   params(18);
zeta        =   params(19);
etag        =   params(20);
theta       =   params(21);
v           =   params(22);
beta        =   params(23);
xiw         =   params(24);
xip         =   params(25);
sigmaa      =   params(26);
sigmaq      =   params(27);
b           =   params(28);
we          =   params(29);
%R           =   params(30);
%m           =   params(31);
%vl          =   params(32);
%vk          =   params(33);
Sdoupr      =   params(34);
tau         =   params(35);
psiL        =   params(36);
ksi         =   params(37);
xb          =   params(38);
pref        =   params(46);
entr        =   params(47);
rhobank     =   params(51);

upsil       =   params(56);
chii        =   params(57);
chorse      =   params(58);
bigtheta    =   params(59);


[A,q,u,pi,RT,Re,Rk,s,ix] = glide1(x,muzstar,beta,tauD,tauk,rk,delta,upsil,ix);

%equation aa5
oom=[.0000001:.1:.99];
ij=0;
omega=oom(1);
[ff(1)] = findomegapert(omega,s,sigma,mu);
for ii = 2:length(oom)
    omega=oom(ii);
    [ff(ii)] = findomegapert(omega,s,sigma,mu);
    if ff(ii)*ff(ii-1) < 0
        ij=ij+1;
        II(ij)=ii;
    end
end
if ij > 1 
    error('(steadysolve) multiple solutions to eq. aa5')
end
if ij < 1 
    error('(steadysolve) no solution to eq. aa5')
end
omega1=oom(II(1)-1);
omega2=oom(II(1));

opt=optimset('diagnostics','off','LevenbergMarquardt','on','TolX',1e-12,'TolFun',1e-12);
[omegabar,fval,exitflag,output] =   fzero(@findomegapert,[omega1,omega2],opt,s,sigma,mu);
if abs(fval ) > .1e-9 | abs(imag(omega))>.1e-10 | exitflag <= 0
    error('fatal (steadysolve) failed to find omega')
end

Fomegabar=logncdf(omegabar,-.5*sigma^2,sigma);

z           =   (log(omegabar)+sigma^2/2)/sigma;
Gamma       =   normcdf(z-sigma)+omegabar*(1-normcdf(z));
G           =   normcdf(z-sigma);
n           =   we/(1-gamma/muzstar*(1+Re)/pi-gamma/(pi*muzstar)*(Rk-Re-mu*(1+Rk)*G)/(1-(1+Rk)/(1+Re)*(Gamma-mu*G)));
k           =   n/(1-((1+Rk)/(1+Re))*(Gamma-mu*G));
if n < 0 | k < 0 | k < n
    error('(steadysolve) n < 0 | k < 0 | k < n')
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%check whether the value we have found for omegabar, n, and k indeed satisfy their respective equations
%equation aa5
ee0         =  (1-Gamma)*s+((1-Fomegabar)/(1-Fomegabar-mu*omegabar*lognpdf(omegabar,-sigma^2/2,sigma))) ...
                  *(s*(Gamma-mu*G)-1);
%equation aa6
ee1         =  (k/n)-1/(1-s*(Gamma-mu*G));

%equation aa7
ee2         =  n-((gamma/(pi*muzstar))*(Rk-Re-mu*G*(1+Rk))*k+we)/(1-gamma*((1+Re)/pi)/muzstar);
if abs(ee1) > .1e-10 | abs(ee2) > .1e-10 | abs(ee0) > .1e-9
    ix(6)=1;
    error('(glide2) eq. aa5, aa6 and/or aa7 are not satisfied')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%equation aa3
i  = k*(1-(1-delta)/(muzstar*upsil));

%start loop on R
Rlow  =  0.003;%0.007154;%   0.00715530828368;%0.001;%  
Rhigh =  0.02;%0.007156;%0.06; %
R=Rlow

% RR=[Rlow:.0000001:Rhigh];
% ij=0;
% R=RR(1);
% try
%     [ffR(1),w,l,y,phi,g,c,vn,uzc,lamz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl] = glidepert(R,alpha,lambdaf,rk,psik,psil,k,muzstar,upsil, ...
%         bigtheta,gamma,n,we,mu,G,Rk,pi,etag,i,b,zeta,psiL,sigmaL,lambdaw,taul,x,theta,Re,tau,chorse,chii,tauD,beta,sigmaq,v, ...
%         tauc,ksi,xb,rhobank,pref);
% catch
% end
% for ii = 2:length(RR)
%     R=RR(ii);
%     try
%         [ffR(ii),w,l,y,phi,g,c,vn,uzc,lamz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl] = glidepert(R,alpha,lambdaf,rk,psik,psil,k,muzstar,upsil, ...
%             bigtheta,gamma,n,we,mu,G,Rk,pi,etag,i,b,zeta,psiL,sigmaL,lambdaw,taul,x,theta,Re,tau,chorse,chii,tauD,beta,sigmaq,v, ...
%             tauc,ksi,xb,rhobank,pref);
%         if ffR(ii)*ffR(ii-1) < 0
%             ij=ij+1;
%             II(ij)=ii;
%         end
%     catch
%     end
% end
% if ij > 1 
%     error('(steadysolve) multiple solutions for R')
% end
% if ij < 1 
%     error('(steadysolve) no solution for R')
% end
% Rlow=RR(II(1)-1);
% Rhigh=RR(II(1));

% [ffR1,w,l,y,phi,g,c,vn,uzc,lamz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl] = glidepert(Rlow,alpha,lambdaf,rk,psik,psil,k,muzstar,upsil, ...
%    bigtheta,gamma,n,we,mu,G,Rk,pi,etag,i,b,zeta,psiL,sigmaL,lambdaw,taul,x,theta,Re,tau,chorse,chii,tauD,beta,sigmaq,v, ...
%    tauc,ksi,xb,rhobank,pref);
% 
% [ffR2,w,l,y,phi,g,c,vn,uzc,lamz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl] = glidepert(Rhigh,alpha,lambdaf,rk,psik,psil,k,muzstar,upsil, ...
%     bigtheta,gamma,n,we,mu,G,Rk,pi,etag,i,b,zeta,psiL,sigmaL,lambdaw,taul,x,theta,Re,tau,chorse,chii,tauD,beta,sigmaq,v, ...
%     tauc,ksi,xb,rhobank,pref);
% if ffR1*ffR2 > 0
%     error('fatal (steadysolve) failed to bracket solution for R')
% end       

opt =optimset('TolFun',1e-12,'TolX',1e-12,'Maxit',100);
[R,fval,exitflag,output] =   fminbnd(@glidepertt,Rlow,Rhigh,opt,alpha,lambdaf,rk,psik,psil,k,muzstar,upsil, ...
    bigtheta,gamma,n,we,mu,G,Rk,pi,etag,i,b,zeta,psiL,sigmaL,lambdaw,taul,x,theta,Re,tau,chorse,chii,tauD,beta,sigmaq,v, ...
    tauc,ksi,xb,rhobank,pref);
if exitflag < 0 | abs(fval) > .5e-8 | abs(imag(R)) > .1e-10 | R<0 
    error('fatal (steadysolve) failed to find R')
end
% 
[ffR,w,l,y,phi,g,c,vn,uzc,lamz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl] = glidepert(R,alpha,lambdaf,rk,psik,psil,k,muzstar,upsil, ...
    bigtheta,gamma,n,we,mu,G,Rk,pi,etag,i,b,zeta,psiL,sigmaL,lambdaw,taul,x,theta,Re,tau,chorse,chii,tauD,beta,sigmaq,v, ...
    tauc,ksi,xb,rhobank,pref);
%end loop on R

%verify whether equation aa14 is satisfied
costs=psil*w*l+psik*rk*k/(upsil*muzstar);
bba=(mb/(pi*muzstar))*(1-m+chorse*dm)+costs;
mmm=bba/(her*erz);
ffrk = ( (ev^(-rhobank)) -1 + mmm )*ksi - (mmm-1);
