do_variance=1;
if do_variance == 1
    
    %Compute the RBC version of the model
    [A_R,B_R,B1_R,P_R,c_R,y_R,g_R,i_R] = RBCsolve(rho,D,pi,muzstar,beta,tauD,tauk,upsil,delta,lambdaf,alpha,b,taul,tauc, ...
        lambdaw,zeta,psiL,etag,Sdoupr,sigmaa,sigmaL,taushock,parstoch,accuracy);
    
    %initialise the alphas and betas for the benchmark model
    irun =0;
    [s_alphas,s_alpha_2,s_alpha_1,s_alpha_0,s_betas,s_beta_0,s_beta_1,taumat,M,sst,ss] = ...
        makealphabeta(lambdaz,g,her,ksi,pi,i,omegabar,Rk,n,ev,mb,uzc,Ra,c,w,Re,m3, ...
                      k,params,q,s,u,dm,vn,RT,Rm,icheck,money,rpl,Taylor,forward,larry,util,costreal, ...
                      static,parstoch,etai,taushock,irun,btot,country,phi,y,R,rk,l,kbar);
    
    
    size_a = size(s_alpha_0);
    size_b = size(s_beta_0);
    
    xiw       = params(8);
    Hdoupr    = params(9);
    iotaw1    = params(17);
    iotaw2    = params(18);
    iotamu    = params(19);
    Sdoupr    = params(27);
    iota1     = params(40);
    iota2     = params(41);
    xip       = params(39);
    aptil     = params(56);
    aytil     = params(57);
    amtil     = params(58);
    actil     = params(59);
    rhotil    = params(60);
    sigmaa    = params(26);

    
    for jh = 1:length(taushock)
        V_eps(jh) = (stdshocks1(taushock(jh)))^2;
    end
    V_eps = diag(V_eps);
    
    l_psi   =   length(rho);
    l_zR    =   length(A_R);
    
    results_td = [];
    results_irf = [];
    results_fd = [];
    noresults = [];
    results=[];
    value0=1000;
    
    for pm_p=0.5:0.1:1 %policy-maker weight on inflation variance (the weight on gdp variance is (1-pm_p))
        for rhotil = 0:0.1:0.9
            for aptil = 1.1:0.1:3
                for aytil = 0:0.1:1
                    %for amtil =0:0.01:0.15
                        try
                            [alphas,alpha_2,alpha_1,alpha_0,betas] = newalphabeta(size_a,size_b,sigmaa,xiw,xip,Sdoupr,Hdoupr,rhotil,aptil,aytil,amtil,actil,iota1,iota2,iotaw1,iotaw2,iotamu);
     
                            [A_B] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0,accuracy);
                            
                            l_zB    =   length(A_B);
                            
                            [B,B1_B,B2,P,rrho,betas] = findandcheckB(A_B,alphas,rho,taushock,taumat,betas);           
                            
                            %construct state space representation
                            N       =   zeros(l_zR+l_psi+l_zB);
                            N(1:l_zR,1:l_zR)                        =   A_R;
                            N(1:l_zR,l_zR+1:l_zR+l_psi)             =   B1_R*rho;
                            N(l_zR+1:l_zR+l_psi,l_zR+1:l_zR+l_psi)  =   rho;
                            N(l_zR+l_psi+1:l_zR+l_psi+l_zB,l_zR+1:l_zR+l_psi)            = B1_B*rho;
                            N(l_zR+l_psi+1:l_zR+l_psi+l_zB,l_zR+l_psi+1:l_zR+l_psi+l_zB) = A_B;
                            
                            Q    =   zeros(l_zR+l_psi+l_zB);
                            Q(1:l_zR,1:l_zR)                         =   B1_R*D*V_eps*D'*B1_R';
                            Q(1:l_zR,l_zR+1:l_zR+l_psi)              =   B1_R*D*V_eps*D';
                            Q(1:l_zR,l_zR+l_psi+1:l_zR+l_psi+l_zB)   =   B1_R*D*V_eps*D'*B1_B';
                            Q(l_zR+1:l_zR+l_psi,1:l_zR)                   =   D*V_eps*D'*B1_R';
                            Q(l_zR+1:l_zR+l_psi,l_zR+1:l_zR+l_psi)        =   D*V_eps*D';
                            Q(l_zR+1:l_zR+l_psi,l_zR+l_psi+1:l_zR+l_psi+l_zB)  = D*V_eps*D'*B1_B';
                            Q(l_zR+l_psi+1:l_zR+l_psi+l_zB,1:l_zR)             = B1_B*D*V_eps*D'*B1_R';
                            Q(l_zR+l_psi+1:l_zR+l_psi+l_zB,l_zR+1:l_zR+l_psi)  = B1_B*D*V_eps*D';
                            Q(l_zR+l_psi+1:l_zR+l_psi+l_zB,l_zR+l_psi+1:l_zR+l_psi+l_zB) =  B1_B*D*V_eps*D'*B1_B';
                            
                            %do mapping from observables to states 
                            [II,l_psi] = findnum(taushock,parstoch);
                            
                            %find the location in psi(t) of muup shock (this is shock #7 in our list of fundamental shocks)
                            shk=7;
                            [tauumuup] = findtau(shk,taushock,II,l_psi);
                            %find the location in psi(t) of ghat
                            shk=13;
                            [tauug] = findtau(shk,taushock,II,l_psi);
                            
                            G_bar = zeros(2,l_zR+l_psi+l_zB);  %the 1th row of G selects the output gap (i.e. the difference between gdp in benchmark and RBC models; the 2nd row selectts inflation
                            G_bar(2,l_zR+l_psi+1) = 1; %select inflation in benchmark model
                            y_zB = zeros(1,length(A_B)); %construct gdp in benchmark model
                            y_zB(4) = i/y;
                            y_zB(18) = c/y;
                            y_psiB = -(i/y)*tauumuup + (g/y)*tauug;
                            
                            y_zR= zeros(1,length(A_R)); %construct gdp in RBC model
                            y_zR(3) = i_R/y_R;
                            y_zR(11) = c_R/y_R;
                            y_psiR = -(i_R/y_R)*tauumuup + (g_R/y_R)*tauug;
                            
                            G_bar(1,1:l_zR ) = -y_zR;
                            G_bar(1,l_zR+1:l_zR+l_psi) = y_psiB-y_psiR;
                            G_bar(1,l_zR+l_psi+1:l_zR+l_psi+l_zB) = y_zB;
                            
                            %compute population second moments in the time domain
                            S_td=1;
                            if S_td==1
                                S_z = ddlyap(N,Q);
                                S_x = G_bar*S_z*G_bar';
                                %results_td = [results_td; rhotil aptil aytil amtil S_x(2,2) S_x(1,1)]; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                value=pm_p*S_x(2,2) + (1-pm_p)*S_x(1,1);
                                if value<value0
                                    value0=value;
                                    results_td = [rhotil aptil aytil amtil S_x(2,2) S_x(1,1) value0]; 
                                end
                            end
                            
                            S_irf =0; %=1 compute population second moments using impulse response functions
                            if S_irf ==1
                                simulate;
                                results_irf = [results_irf; rhotil aptil infhat*infhat' (Y-out_R)*(Y-out_R)'];
                            end
                            
                            S_fd =0; %=1 compute population second moments in the frequency domain
                            if S_fd ==1
                                im = (-1)^(1/2);
                                ppi = imag(log(-1));
                                for om = -ppi:1:ppi 
                                    Sptrum = inv( eye(l_zR+l_psi+l_zB) - N*e^(-im*om) )*Q*inv( eye(l_zR+l_psi+l_zB) - N'*e^(im*om) );
                                end
                                [S_z_fd] = ifft(Sptrum); %maybe ifftn ??
                                S_x_fd = G_bar*S_z_fd*G_bar';
                                results_fd = [results_fd; rhotil aptil S_x_fd(2,2) S_x_fd(1,1)];
                            end
                        catch
                            lasterr
                            lasterr('')
                            noresults=[noresults; rhotil aptil aytil amtil];
                            %results_td = [results_td; rhotil aptil Inf Inf];
                        end
                        %end
                    end
                    end
        end
        results = [results; pm_p results_td]; %pm_p rhotil aptil aytil amtil var_p var_y value
        results_td = [];
        value0=1000;
    end
    
    %plot trade-off        
    String1=['Trade-off Curves'];
    if S_td ==1
        figure
        %plot(results_td(1:10,5),results_td(1:10,6),'b.-',results_td(11:20,5),results_td(11:20,6),'r.-')
        xlabel('variance of inflation')
        ylabel('variance of (y-y*)')
        hout=suptitle(String1);
    end
    
    if S_irf ==1
        figure
        plot(results_irf(:,3),results_irf(:,4),'b.-')
        xlabel('variance of inflation')
        ylabel('variance of (y-y*)')
        hout=suptitle(String1);
    end
    
    if S_fd ==1
        figure
        plot(results_fd(:,3),results_fd(:,4),'b.-')
        xlabel('variance of inflation')
        ylabel('variance of (y-y*)')
        hout=suptitle(String1);
    end
end

% y_gap=Y(tt)-out_R(tt);
% vb=[];
% vb = [y_gap(tt)', M3(tt)'];
% Dvb(1,1:2) = vb(1,:);
% for gg=2:1:tt(end)
%     Dvb(gg,:) = vb(gg,:)-vb(gg-1,:);
% end
% figure; plot(tt,0.01*realrate_R(tt),'k.-',tt,4.5*Dvb(:,1)','r.-',tt,(Dvb(:,2)'-infhat(tt)),'g.-')
% 
% corrcoef(0.01*realrate_R(tt),Dvb(:,2)'-infhat(tt))
% corrcoef(0.01*realrate_R(tt),4.5*Dvb(:,1)')
% corrcoef((Dvb(:,2)'-infhat(tt)),4.5*Dvb(:,1)')
