function vardecomp(H,F,Q,V_eps,R,B1,D,is,index_l,fdiff,tauvar,taushock,categ,cmap,signal_on,Corr_sample, ...
    Relvar_sample,outfolder,entr,cdir,Xdat_s,ric,l_z,l_psi,parstoch)

N = 1000;
cycle1 = 8; %2 8 define the business cycle as fluctuations between 8 quarters and 32 quarters
cycle2 = 32; %10000 32


NN = N/2;

om = 2*pi*[(1:NN+1)-1]/N;
%om = om/10000;

year8=[];
year2=[];
for jj = 1: length(om)
    if om(jj) > 0.18 && om(jj) < 0.20 % 2*pi/32 where 32 is the number of quarters
        year8 = jj;
    elseif om(jj) > 0.77 && om(jj) < 0.79 %2*pi/8 where 8 is the number of quarters
        year2 = jj;
    end
end


z = exp(-sqrt(-1)*om);

index = ones(1,length(tauvar)); 
II = [];
for jj=1:length(index_l)
        II = [II find(tauvar==index_l(jj))];
end


GG = [B1*D; zeros(size(B1*D)); D];
if is ==1
    GG = [GG; zeros(size(D))];
end

for ii = 2:length(z)
    zz = z(ii);
    index(II) = 1/(1-zz);
    DD = diag(index);
    
    S_y = DD*H*inv(eye(size(F)) - F*zz);
    
    DRD = DD*R*DD';
    
    Spec(:,:,ii-1) = S_y*Q*S_y' + DRD;
    
    checkjj = zeros(size(Spec,1),size(Spec,1));
    for jj = 1:size(V_eps)
                
        qq = zeros(1,length(V_eps));
        qq(jj) = V_eps(jj,jj);
        VV_eps = diag(qq);
        
        QQ = GG*VV_eps*GG';
                
        Spec_jj(:,:,ii-1,jj) = S_y*QQ*S_y'; 
        checkjj = checkjj + Spec_jj(:,:,ii-1,jj);
    end    
    Spec_jj(:,:,ii-1,jj+1) = DRD;
    
    if max(max(checkjj+DRD - Spec(:,:,ii-1))) >1.e-10; 
        error('fatal (vardecomp) sum of individual shock contributions do not not sum up to total');
    end
    
    
    for jk = 1:size(categ,1)
        qq = zeros(1,length(V_eps));
        qq(categ{jk,2}) = diag(V_eps(categ{jk,2},categ{jk,2}));
        VV_eps = diag(qq);
        
        QQ = GG*VV_eps*GG';
                
        Spec_categ(:,:,ii-1,jk) = S_y*QQ*S_y'; 
    end
    Spec_categ(:,:,ii-1,jk+1) = DRD;   
        
end

%business cycle frequency
N_l = ceil(N/cycle2);
N_h = ceil(N/cycle1);
flag1 = 1; 
if isempty(year2) || isempty(year8)
    flag1 = 0;
end
Spec_bc(:,:) = Spec(:,:,N_l);
Spec_jj_bc(:,:,:) = Spec_jj(:,:,N_l,:);
for ii=N_l+1:N_h
    Spec_bc(:,:) = Spec_bc(:,:) + Spec(:,:,ii);
    Spec_temp(:,:,:) = Spec_jj(:,:,ii,:);
    Spec_jj_bc(:,:,:) = Spec_jj_bc(:,:,:) + Spec_temp;
end

%low frequency
N_low = N_l-1;
Spec_lf(:,:) = Spec(:,:,1);
Spec_jj_lf(:,:,:) = Spec_jj(:,:,1,:);
for ii= 1+1:N_low
    Spec_lf(:,:) = Spec_lf(:,:) + Spec(:,:,ii);
    Spec_temp(:,:,:) = Spec_jj(:,:,ii,:);
    Spec_jj_lf(:,:,:) = Spec_jj_lf(:,:,:) + Spec_temp;
end
%

%unload results
for ii=1:size(Spec_jj,3)
    for ij =1:size(H,1)
        for jj=1:size(V_eps)
            Var_dec(ii,jj,ij) = 100 * Spec_jj(ij,ij,ii,jj) / Spec(ij,ij,ii);
        end
        Var_dec(ii,jj+1,ij) = 100 * Spec_jj(ij,ij,ii,jj+1) / Spec(ij,ij,ii);
    end
end


for ij =1:size(H,1)
    for jj=1:size(V_eps)
        Var_dec_bc(ij,jj) = 100 * Spec_jj_bc(ij,ij,jj) / Spec_bc(ij,ij);
    end
    Var_dec_bc(ij,jj+1) = 100 * Spec_jj_bc(ij,ij,jj+1) / Spec_bc(ij,ij);
end
if max(max(abs(imag(Var_dec_bc)))) > .1e-0 
    error('fatal (varddecomp) imaginary part is not zero')
end
Var_dec_bc=real(Var_dec_bc);


for ij =1:size(H,1)
    for jj=1:size(V_eps)
        Var_dec_lf(ij,jj) = 100 * Spec_jj_lf(ij,ij,jj) / Spec_lf(ij,ij);
    end
    Var_dec_lf(ij,jj+1) = 100 * Spec_jj_lf(ij,ij,jj+1) / Spec_lf(ij,ij);
end
if max(max(abs(imag(Var_dec_lf)))) > .1e-0 
    error('fatal (varddecomp) imaginary part is not zero')
end
Var_dec_lf=real(Var_dec_lf);


for ii=1:size(Spec_categ,3)
    for ij =1:size(H,1)
        for jj=1:size(categ,1)
            Var_dec_categ(ii,jj,ij) = 100 * Spec_categ(ij,ij,ii,jj) / Spec(ij,ij,ii);
        end
        Var_dec_categ(ii,jj+1,ij) = 100 * Spec_categ(ij,ij,ii,jj+1) / Spec(ij,ij,ii);
    end
end

[nameshocks,nameXXX] = getnames(fdiff);
givenames
nameshocks_l= strrep(shockss(taushock(1),:),'\','\\');
if max(signal_on==taushock(1))==1
    for hh = 1:parstoch(taushock(1))
        nameshocks_l = char(nameshocks_l,['Signal ',num2str(hh),', ' strrep(shockss(taushock(1),:),'\','\\')]);
    end
end
for kk=2:length(taushock)
    nameshocks_l = char(nameshocks_l,strrep(shockss(taushock(kk),:),'\','\\'));
    if max(signal_on==taushock(kk))==1
        for hh = 1:parstoch(taushock(kk))
            nameshocks_l = char(nameshocks_l,['Signal ',num2str(hh),', ' strrep(shockss(taushock(kk),:),'\','\\')]);
        end
    end
end
nameshocks_long = char(nameshocks_l,'Meas. Err.');
nameXX = nameXXX(tauvar,:);

if entr==1; subscr='cmr'; elseif entr==2; subscr='nofish'; elseif entr==0; subscr='nobank'; elseif entr==-2; subscr='sw'; elseif entr==-3; subscr='bgg'; elseif entr==-4; subscr='bgg_nofish'; end
%compile Tables with variance decomposition at business cycle and low frequencies
if flag1==1
    table_vardec(outfolder,nameshocks_long,nameXX,Var_dec_bc,cycle1,cycle2,['table_vardec_bc_' subscr '.tex'],entr,'Business Cycle',cdir,1);
    table_vardec(outfolder,nameshocks_long,nameXX,Var_dec_lf,cycle2+1,ceil(2*pi/om(2)),['table_vardec_lf_' subscr '.tex'],entr,'Low',cdir,2);
end

%compile Table with variance decomposition computed in sample
table_vardec_sample(outfolder,nameshocks_long,nameXX,Corr_sample,Relvar_sample,['table_vardec_sample_' subscr '.tex'],entr,cdir);

%compute model-implied standard deviation
[std_data,std_implied] = modelvariance(Xdat_s,F,H,R,Q,ric,is,l_z,l_psi,fdiff,tauvar,entr);

if flag1==1
    if entr==1
        tauvar_cmr = tauvar;
        taushock_cmr = taushock;
        signal_cmr = signal_on;
        Vardec_bc_cmr = round(Var_dec_bc);
        Vardec_lf_cmr = round(Var_dec_lf);
        Corr_sample_cmr = Corr_sample;
        Relvar_sample_cmr = Relvar_sample;
        std_implied_cmr = std_implied;
        std_data_cmr = std_data;
        nameshocks_cmr = nameshocks_long;
        nameXXX_cmr = nameXXX;
        save([outfolder '\vardec_cmr.mat'], 'nameshocks_cmr','nameXXX_cmr', 'tauvar_cmr','taushock_cmr', 'signal_cmr', 'Vardec_bc_cmr', 'Vardec_lf_cmr', 'Corr_sample_cmr', 'Relvar_sample_cmr', 'std_implied_cmr','std_data_cmr')

    elseif entr ==-3
        tauvar_bgg = tauvar;
        taushock_bgg = taushock;
        signal_bgg = signal_on;
        Vardec_bc_bgg = round(Var_dec_bc);
        Vardec_lf_bgg = round(Var_dec_lf);
        Corr_sample_bgg = Corr_sample;
        Relvar_sample_bgg = Relvar_sample;
        std_implied_bgg = std_implied;
        save([outfolder '\vardec_bgg.mat'], 'tauvar_bgg', 'taushock_bgg', 'signal_bgg', 'Vardec_bc_bgg', 'Vardec_lf_bgg', 'Corr_sample_bgg', 'Relvar_sample_bgg', 'std_implied_bgg')

    elseif entr ==0
        tauvar_b = tauvar;
        taushock_b = taushock;
        signal_b = signal_on;
        Vardec_bc_b = round(Var_dec_bc);
        Vardec_lf_b = round(Var_dec_lf);
        Corr_sample_b = Corr_sample;
        Relvar_sample_b = Relvar_sample;
        std_implied_b = std_implied;
        save([outfolder '\vardec_b.mat'], 'tauvar_b', 'taushock_b', 'signal_b', 'Vardec_bc_b', 'Vardec_lf_b', 'Corr_sample_b', 'Relvar_sample_b', 'std_implied_b')

    elseif entr==2
        tauvar_fish = tauvar;
        taushock_fish = taushock;
        signal_fish = signal_on;
        Vardec_bc_fish = round(Var_dec_bc);
        Vardec_lf_fish = round(Var_dec_lf);
        Corr_sample_fish = Corr_sample;
        Relvar_sample_fish = Relvar_sample;
        std_implied_fish = std_implied;
        save([outfolder '\vardec_fish.mat'], 'tauvar_fish', 'taushock_fish', 'signal_fish', 'Vardec_bc_fish', 'Vardec_lf_fish', 'Corr_sample_fish', 'Relvar_sample_fish', 'std_implied_fish')

    elseif entr==-2
        tauvar_sw = tauvar;
        taushock_sw = taushock;
        signal_sw = signal_on;
        Vardec_bc_sw = round(Var_dec_bc);
        Vardec_lf_sw = round(Var_dec_lf);
        Corr_sample_sw = Corr_sample;
        Relvar_sample_sw = Relvar_sample;
        std_implied_sw = std_implied;
        save([outfolder '\vardec_sw.mat'], 'tauvar_sw', 'taushock_sw', 'signal_sw', 'Vardec_bc_sw', 'Vardec_lf_sw', 'Corr_sample_sw', 'Relvar_sample_sw', 'std_implied_sw');
    
    elseif entr==-4
        error('fatal (vardecomp) entr=-4 and code is not ready for that')
    end
end

flag2=0; %=1 to construct big tables displaying all alternative models; =0 do nothing
if flag1==1 && flag2==1
    load([outfolder '\vardec_cmr.mat']) %this line needs to be present and loaded to compile big table; if in the big table you don't want some of the alternative models below, use empty matrices for them
    load([outfolder '\vardec_bgg.mat']); %tauvar_bgg=[]; taushock_bgg=[]; Vardec_bc_bgg=[]; Vardec_lf_bgg=[]; signal_bgg=[]; Corr_sample_bgg=[]; Relvar_sample_bgg=[]; std_implied_bgg=[]; %load([outfolder '\vardec_bgg.mat'])
    tauvar_b=[]; taushock_b=[]; Vardec_bc_b=[]; Vardec_lf_b=[]; signal_b=[]; Corr_sample_b=[]; Relvar_sample_b=[]; std_implied_b=[]; %load([outfolder '\vardec_b.mat'])
    tauvar_fish=[]; taushock_fish=[]; Vardec_bc_fish=[]; Vardec_lf_fish=[]; signal_fish=[]; Corr_sample_fish=[]; Relvar_sample_fish=[]; std_implied_fish=[]; %load([outfolder '\vardec_fish.mat'])
    load([outfolder '\vardec_sw.mat'])

    %business cycle frequency
    maketable_vardec(Vardec_bc_cmr,Vardec_bc_fish,Vardec_bc_bgg,Vardec_bc_sw,Vardec_bc_b,cycle1,cycle2,'table_vardec_all_bc.tex','Business Cycle', ...
        nameshocks_cmr,nameXXX_cmr,taushock_cmr,taushock_bgg,taushock_b,taushock_fish,taushock_sw,tauvar_cmr,tauvar_bgg,tauvar_b,tauvar_fish,tauvar_sw,signal_cmr,signal_bgg,signal_b,signal_fish,signal_sw,outfolder,cdir,parstoch,1)

    %low frequencies
    maketable_vardec(Vardec_lf_cmr,Vardec_lf_fish,Vardec_lf_bgg,Vardec_lf_sw,Vardec_lf_b,cycle2+1,ceil(2*pi/om(2)),'table_vardec_all_lf.tex','Low', ...
        nameshocks_cmr,nameXXX_cmr,taushock_cmr,taushock_bgg,taushock_b,taushock_fish,taushock_sw,tauvar_cmr,tauvar_bgg,tauvar_b,tauvar_fish,tauvar_sw,signal_cmr,signal_bgg,signal_b,signal_fish,signal_sw,outfolder,cdir,parstoch,2)
 
    %in-sample variance decomposition
    maketable_vardec_sample(Corr_sample_cmr,Corr_sample_fish,Corr_sample_bgg,Corr_sample_sw,Corr_sample_b,Relvar_sample_cmr,Relvar_sample_fish,Relvar_sample_bgg,Relvar_sample_sw,Relvar_sample_b, ...
        'table_vardec_all_sample.tex',nameshocks_cmr,nameXXX_cmr,taushock_cmr,taushock_bgg,taushock_b,taushock_fish,taushock_sw,tauvar_cmr,tauvar_bgg,tauvar_b,tauvar_fish,tauvar_sw,signal_cmr,signal_bgg,signal_b,signal_fish,signal_sw,outfolder,cdir,parstoch)

    %compute model-implied standard deviation
    maketable_modelvariance(std_data_cmr,std_implied_cmr,std_implied_fish,std_implied_bgg,std_implied_sw,std_implied_b, ...
        'table_implied_std_all.tex',nameXXX_cmr,tauvar_cmr,tauvar_bgg,tauvar_b,tauvar_fish,tauvar_sw,outfolder,parstoch);
end

return
%the second to last line below generates an error message.
%plotting results
tt1 = om(2:end);
n_row = 4;
n_col = 4;

figure; orient landscape
for kk=1:size(H,1)
    subplot(n_row,n_col,kk)
    
    VV_dec = Var_dec(:,:,kk) ;
    bar(om(2:end),VV_dec(1:end,:),'stacked')
    %xlabel('frequencies')
    
    if isempty(year8)==0
    line('XData',[tt1(year8), tt1(year8)],'YData',[0,100],'LineStyle','-','LineWidth',2, 'Color',[0.5 0.5 0.5])
    line('XData',[tt1(year2), tt1(year2)],'YData',[0,100],'LineStyle','-','LineWidth',2, 'Color',[0.5 0.5 0.5])
    end
    
    title(nameXX(kk,:))
    axis tight
end

leg = legend(nameshocks_long);
set(leg, 'FontSize', 7,'Location','SouthEast');
hout = suptitle('Figure: Variance Decomposition at Different Frequency');

figure, orient landscape
K=[find(tauvar==1) find(tauvar==2) find(tauvar==3) find(tauvar==5)];
ix=0;
for kk=K
    ix=ix+1;
    subplot(2,2,ix)
    
    VV_dec = Var_dec(:,:,kk) ;
    bar(om(2:end),VV_dec(:,:),'stacked')
    
    if isempty(year8)==0
    line('XData',[tt1(year8), tt1(year8)],'YData',[0,100],'LineStyle','-','LineWidth',2, 'Color',[0.5 0.5 0.5])
    line('XData',[tt1(year2), tt1(year2)],'YData',[0,100],'LineStyle','-','LineWidth',2, 'Color',[0.5 0.5 0.5])
    end

    title(nameXX(kk,:))
    xlabel('frequencies')
    axis tight
end
leg = legend(nameshocks_long);
set(leg, 'FontSize', 7,'Location','SouthEast');
hout = suptitle('Figure: Variance Decomposition at Different Frequency');

figure, orient landscape
K=[find(tauvar==7) find(tauvar==10) find(tauvar==11) find(tauvar==14)];
ix=0;
for kk=K
    ix=ix+1;
    subplot(2,2,ix)
    
    VV_dec = Var_dec(:,:,kk) ;
    bar(om(2:end),VV_dec(:,:),'stacked')
    
    if isempty(year8)==0
    line('XData',[tt1(year8), tt1(year8)],'YData',[0,100],'LineStyle','-','LineWidth',2, 'Color',[0.5 0.5 0.5])
    line('XData',[tt1(year2), tt1(year2)],'YData',[0,100],'LineStyle','-','LineWidth',2, 'Color',[0.5 0.5 0.5])
    end

    title(nameXX(kk,:))
    xlabel('frequencies')
    axis tight
end
leg = legend(nameshocks_long);
set(leg, 'FontSize', 7,'Location','SouthEast');
hout = suptitle('Figure: Variance Decomposition at Different Frequency');

%plot variance decomposition using categories rather than individual shocks
figure; orient landscape
for kk=1:size(H,1)
    subplot(n_row,n_col,kk)
    
    VV_dec = Var_dec_categ(:,:,kk) ;
    bar(om(2:end),VV_dec(1:end,:),'stacked')
    colormap(cmap)
    %xlabel('frequencies')
    
    if isempty(year8)==0
    line('XData',[tt1(year8), tt1(year8)],'YData',[0,100],'LineStyle','-','LineWidth',2, 'Color',[0.5 0.5 0.5])
    line('XData',[tt1(year2), tt1(year2)],'YData',[0,100],'LineStyle','-','LineWidth',2, 'Color',[0.5 0.5 0.5])
    end
    
    title(nameXX(kk,:))
    axis tight
end
name_categ = categ(:,1);
leg = legend(char([name_categ(:,:);'Measurement Error']));
set(leg, 'FontSize', 7,'Location','SouthEast');
hout = suptitle('Figure: Variance Decomposition at Different Frequency. Shocks are Grouped into Homogeneous Categories');