%This program computes a new IRFdatLV in accordance with the most recent version of VAR programs sent by
%Rob Vigfusson 2002-10-01.
%Written and last modified 2002-10-13 by Jesper Lind.

nper = 32;
nvars = 10;
multplyby = diag([100 400 400 1 100 100 100 100 100 100]); %scaling to fit data and model.
fflocation = 8; %location of fed funds shock in the VAR.
unitechloc = 1; %location of unitroot technology shock in the VAR.

load([cdir '\malev']); %matrix containing all the impulse response functions. Size: nvars x nshocks x nperiods.

%load IRFdatLV
% Variables in malev (first dimension) are ordered as:
%  1 output
%  2 money growth  
%  3 inflation
%  4 nominal interest rate
%  5 capacity utilization
%  6 hours worked
%  7 wage
%  8 consumption
%  9 investment
% 10 velocity


%First, compute point estimates for impulse response functions.

%Policy shock.
IRFFF =  -(squeeze(malev(:,fflocation,1:nper-2))')*multplyby; %considering a expansionary policy shock.
IRFFF = [zeros(2,nvars);IRFFF];
%Unitroot technology shock.
IRFx = (squeeze(malev(:,unitechloc,1:nper-2))')*multplyby;
IRFx = [zeros(2,nvars);IRFx];

load([cdir '\IRFdatLV']);

tt=3:22;
yvar(:,[1:2])=[IRFFF(tt,1),IRFFFSE(tt,1)];
mvar(:,[1:2])=[IRFFF(tt,2),IRFFFSE(tt,2)];
infvar(:,[1:2])=[IRFFF(tt,3),IRFFFSE(tt,3)];
Rvar(:,[1:2])=[IRFFF(tt,4),IRFFFSE(tt,4)];
cuvar(:,[1:2])=[IRFFF(tt,5),IRFFFSE(tt,5)];
hvar(:,[1:2])=[IRFFF(tt,6),IRFFFSE(tt,6)];
wvar(:,[1:2])=[IRFFF(tt,7),IRFFFSE(tt,7)];
cvar(:,[1:2])=[IRFFF(tt,8),IRFFFSE(tt,8)];
ivar(:,[1:2])=[IRFFF(tt,9),IRFFFSE(tt,9)];
vvar(:,[1:2])=[IRFFF(tt,10),IRFFFSE(tt,10)];

yvarz(:,[1:2])=[IRFx(tt,1),IRFxSE(tt,1)];
mvarz(:,[1:2])=[IRFx(tt,2),IRFxSE(tt,2)];
infvarz(:,[1:2])=[IRFx(tt,3),IRFxSE(tt,3)];
Rvarz(:,[1:2])=[IRFx(tt,4),IRFxSE(tt,4)];
cuvarz(:,[1:2])=[IRFx(tt,5),IRFxSE(tt,5)];
hvarz(:,[1:2])=[IRFx(tt,6),IRFxSE(tt,6)];
wvarz(:,[1:2])=[IRFx(tt,7),IRFxSE(tt,7)];
cvarz(:,[1:2])=[IRFx(tt,8),IRFxSE(tt,8)];
ivarz(:,[1:2])=[IRFx(tt,9),IRFxSE(tt,9)];
vvarz(:,[1:2])=[IRFx(tt,10),IRFxSE(tt,10)];

if taushock(ij) == 19
    ty=1:20;
    str='Figure : Response, Monetary Policy Shock (US VAR: +, Model: Solid)';
    figure
    pltout(yhat,yvar,Rehatp,Re,Rvar,infhat,infvar,chat,cvar,ihat,ivar,lhat,hvar,uhat,cuvar, ...
        what,wvar,gm1,pi,muzstar,mvar,velm1t,velm1,vvar,str,xt,x,Rhat,R,velbasehat,ty);
    hold
end
if taushock(ij) == 16
    ty=1:20;
    figure
    str='Figure : Response to Permanent Technology Shock (US VAR: +, Model: Solid)';
    pltout(Y,yvarz,Rehatp,Re,Rvarz,infhat,infvarz,C,cvarz,I,ivarz,lhat,hvarz,uhat,cuvarz, ...
        Wage,wvarz,gm1,pi,muzstar,mvarz,velm1t,velm1,vvarz,str,xt,x,Rhat,R,velbasehat,ty);
end
