infl=(1+0.025)^(1/4);
R=infl/beta;
sp1=1.0126;
mu=0.33;

%first get a baseline value for sigma and the other variables
Fomegabar=.0130;
[sigma,omegabar,Gamma,Gam_muG,ixx] = getomega(sp1,Fomegabar,mu);

lev=[];
Pe=[];
%now, compute the equilibrium starting from just the primitive parameters
mmu=.33:-.01:.02;
for ii = 1:length(mmu)
    xmu=mmu(ii);
    [omega,G,F,Gamma,Gam_muG,Fprime,er] = ffindomeg(sigma,xmu,sp1);
    lev(ii)=1/(1-Gam_muG*sp1);
    Pe(ii)=sp1*omega*lev(ii)/(lev(ii)-1);
end
ia=3;
ib=2;
subplot(ia,ib,1)
plot(mmu,lev)
ylabel('leverage')
xlabel('\mu')
axis tight
subplot(ia,ib,2)
plot(mmu,400*(Pe-1))
ylabel('400*(Z/R-1)')
xlabel('\mu')
axis tight

lev=[];
Pe=[];
ssp1=1.001:.005:1.03;
for ii = 1:length(ssp1)
    xsp1=ssp1(ii);
    [omega,G,F,Gamma,Gam_muG,Fprime,er] = ffindomeg(sigma,mu,xsp1);
    lev(ii)=1/(1-Gam_muG*sp1);
    Pe(ii)=sp1*omega*lev(ii)/(lev(ii)-1);
end
subplot(ia,ib,3)
plot(400*(ssp1-1),lev)
ylabel('leverage')
xlabel('400*(Rk/R-1)')
axis tight
subplot(ia,ib,4)
plot(400*(ssp1-1),400*(Pe-1))
ylabel('400*(Z/R-1)')
xlabel('400*(Rk/R-1)')
axis tight

lev=[];
Pe=[];
ssigma=0.03:.01:1;
for ii = 1:length(ssigma)
    xsigma=ssigma(ii);
    [omega,G,F,Gamma,Gam_muG,Fprime,er] = ffindomeg(xsigma,mu,sp1);
    lev(ii)=1/(1-Gam_muG*sp1);
    Pe(ii)=sp1*omega*lev(ii)/(lev(ii)-1);
end
subplot(ia,ib,5)
plot(ssigma,lev)
ylabel('leverage')
xlabel('\sigma')
axis tight
subplot(ia,ib,6)
plot(ssigma,400*(Pe-1))
ylabel('400*(Z/R-1)')
xlabel('\sigma')
axis tight